program prospettiva (input,output);
{$IFDEF CPU87} {$N+} {$ELSE} {$N-} {$ENDIF}
{$G+}
uses crt,graph,dos,funi1,funi2;
const rad=0.3535534;
      corr=0.7292;
      memnecc=74000;
type  punto2D=record
                xs:integer;
                ys:integer;
             end;
                                  {Lista di legami del vertice }
     Lpunt=^Lega;                 {con altri vertici del solido}
     Lega=record
            Rif:pointer;
            Lsucc:Lpunt;
          end;
     Vpunt=^Vertice;              {Lista dei vertici che ha al suo}
     Vertice=record               {interno la lista dei legami    }
                Vcod:integer;
                Vcoord:Punto3D;
                Vsucc:Vpunt;
                Link:Lpunt;
             end;
     {Konst definito in Funi1}
     tre=array[1..3] of real;
     Tgradi=record               {Questo tipo di variabile "ricorda"}
              x:char;            {le funzioni che regolano il moto  }
              cx:Konst;          {del corpo rigido (tipo di funzione}
              y:char;            {e relativi parametri)             }
              cy:Konst;
              z:char;
              cz:Konst;
              fi:char;
              cf:Konst;
              teta:char;
              ct:Konst;
              cxi:char;
              ci:Konst;
            end;
     Prime=record
             x1,y1,z1:real;
             fi1,teta1,cxi1:real;
           end;
     Angoli=record
              cosfi:real;
              senfi:real;
              costeta:real;
              senteta:real;
              coscxi:real;
              sencxi:real;
            end;
     Rcoeff=array[1..3,1..3] of real;

var PA:Vpunt;
    i,j,t,n,scala,code,passo:integer;
    Temp,Bar:Punto3D;
    distance,quote,xc,yc:real;  {Sono le uniche varibili globali del      }
    Verr:boolean;               {programma, e riportano la distanza       }
    ch,key,moto,func,cti:char;  {dell'osservatore dal quadro di proiezione}
    store,fun,fil,fil2:text;    {e la sua quota                           }
    st,stf,stsic,stfsic:string;
    Bch,Sch,overch,colch,EndKey:char;
    qpiano,qaus,mem,tempo:real;
    grad,deri:Tgradi;
    EsN,fontpath:text;
    Param,stsalvo,stfsalvo,assoluto,traslazione:boolean;
    fontst,fontaus:string;
    ciclo:longint;
    oldporta:viewporttype;
    Aus:punto3d;               {Il tipo Punto3d  definito nella Unit FUNI2}

{fine dichiarazione variabili globali}

function lunga(PA:Vpunt):integer;
var l:integer;
begin
  l:=0;                      {Valuta la lunghezza della lista dei vertici}
  while PA<>nil do
  begin
    l:=l+1;
    PA:=PA^.Vsucc;
  end;
  lunga:=l;
end;

function zeri(tipo:char;c:Konst):boolean;
var zero:boolean;
    min:real;                      {Controlla se la funzione tipo ha}
    i:integer;                     {tutti i coefficenti nulli       }
begin
  zero:=true;
  min:=0.000001;
  for i:=1 to 4 do
  zero:=zero and (abs(c[i])<min);
  zeri:=zero;
end;

function checkpiana(grad,der:Tgradi):boolean;
var roto:boolean;
begin                           {Controlla se il moto  piano}
  with der do
  checkpiana:=zeri(z,cz) and zeri(teta,ct) and zeri(grad.teta,grad.ct);
end;


{Definizione funzioni matematiche usate}

function linear (t,coeff,noto:real):real;
begin
  linear:=coeff*t+noto;
end;

function seno (t,puls,fase,amp,noto:real):real;
begin
  seno:=amp*sin(puls*t+fase)+noto;
end;

function cseno (t,puls,fase,amp,noto:real):real;
begin
  cseno:=amp*cos(puls*t+fase)+noto;
end;

function esp (t,coeff,fase,amp,noto:real):real;
begin
  esp:=amp*exp(t*coeff+fase)+noto;
end;

function loge (t,coeff,fase,amp,noto:real):real;
var arg:real;
begin
  arg:=t*coeff+fase;
  if arg<=0 then arg:=0.0000001;
  loge:=amp*ln(arg)+noto;
end;

function quadr(t,A,B,C:real):real;
begin
  quadr:=A*t*t+B*t+C;
end;

function frazio(t,coeff,den,prop,noto:real):real;
var arg:real;
begin
  arg:=coeff*t+den;
  if arg=0 then arg:=0.00001;
  frazio:=prop/arg+noto;
end;

function calc (Tipo:char;t:real;c:Konst):real;
begin
  case tipo of                           {Calcola il valore della funzione }
    'L':calc:=linear(t,c[1],c[2]);       {valutando l'espressione da "Tipo"}
    'Q':calc:=quadr(t,c[1],c[2],c[3]);
    'S':calc:=seno(t,c[1],c[2],c[3],c[4]);
    'C':calc:=cseno(t,c[1],c[2],c[3],c[4]);
    'E':calc:=esp(t,c[1],c[2],c[3],c[4]);
    'N':calc:=loge(t,c[1],c[2],c[3],c[4]);
    'F':calc:=frazio(t,c[1],c[2],c[3],c[4]);
  end;
end;

procedure input(var grad:Tgradi);
var ch:char;                      {Acquisisce le 6 funzioni che determinano}
                                  {il moto dal canale standar di input     }

procedure mostra (var ch:char;var c1,c2,c3,c4:real);
var x,y:integer;

function car(ch:char):boolean;      {Controlla che il carattere sia corretto}
begin
  car:=(ch='L') or (ch='Q') or (ch='F') or (ch='C') or (ch='S') or (ch='E')
       or (ch='N');
end;
         
begin
  writeln('Funzioni disponibili :');
  textcolor(white);write('L');textcolor(7);writeln('ineare');
  textcolor(white);write('Q');textcolor(7);writeln('uadratica');
  textcolor(white);write('F');textcolor(7);writeln('razionaria');
  textcolor(white);write('S');textcolor(7);writeln('eno');
  textcolor(white);write('C');textcolor(7);writeln('oseno');
  textcolor(white);write('E');textcolor(7);writeln('sponenziale');
  write('Logaritmica ');textcolor(white);write('N');textcolor(7);writeln('aturale');
  writeln;write('Immettere scelta :');
  repeat
    x:=wherex; y:=wherey;
    ch:=UpCase(readkey);writeln(ch);
    if not car(ch) then
    begin
      write(#7);
      gotoxy(x,y);
      write(' ':5);
      gotoxy(x,y);
    end;
  until car(ch);
  writeln;
  write('Variazione :');textcolor(white);write('(t)=');
  case ch of
  'L':begin
        writeln('At+B');
        textcolor(7);
        write('Immettere A :');readreal(c1);
        write('Immettere B :');readreal(c2);
        c3:=0;
        c4:=0;
      end;
  'S':begin
        writeln('sen(wt+f)+');
        textcolor(7);
        write('Immettere w :');readreal(c1);
        write('Immettere f :');readreal(c2);
        write('Immettere  :');readreal(c3);
        write('Immettere  :');readreal(c4);
      end;
  'N':begin
        writeln('ln(wt+f)+');
        textcolor(7);
        write('Immettere w :');readreal(c1);
        write('Immettere f :');readreal(c2);
        write('Immettere  :');readreal(c3);
        write('Immettere  :');readreal(c4);
      end;
  'C':begin
        writeln('cos(wt+f)+');
        textcolor(7);
        write('Immettere w :');readreal(c1);
        write('Immettere f :');readreal(c2);
        write('Immettere  :');readreal(c3);
        write('Immettere  :');readreal(c4);
      end;
  'E':begin
        writeln('exp(t+)+');
        textcolor(7);
        write('Immettere  :');readreal(c1);
        write('Immettere  :');readreal(c2);
        write('Immettere  :');readreal(c3);
        write('Immettere  :');readreal(c4);
      end;
  'Q':begin
        writeln('t+t+');
        textcolor(7);
        write('Immettere  :');readreal(c1);
        write('Immettere  :');readreal(c2);
        write('Immettere  :');readreal(c3);
        c4:=0;
      end;
  'F':begin
        writeln('/(wt+f)+');
        textcolor(7);
        write('Immettere w :');readreal(c1);
        write('Immettere f :');readreal(c2);
        write('Immettere  :');readreal(c3);
        write('Immettere  :');readreal(c4);
      end;
  end;
end;

{corpo principale della procedura}
begin
  with grad do
  begin
    clrscr;
    textcolor(white);
    writeln('Introdurre legge di variazione dell'' angolo di precessione');
    textcolor(7);
    mostra(fi,cf[1],cf[2],cf[3],cf[4]);
    clrscr;
    textcolor(white);
    writeln('Introdurre legge di variazione dell'' angolo di nutazione');
    textcolor(7);
    mostra(teta,ct[1],ct[2],ct[3],ct[4]);
    clrscr;
    textcolor(white);
    writeln('Introdurre legge di variazione dell'' angolo di rotazione propria');
    textcolor(7);
    mostra(cxi,ci[1],ci[2],ci[3],ci[4]);
    clrscr;
    textcolor(white);
    writeln('Introdurre legge di variazione dell'' ascissa del baricentro');
    textcolor(7);
    mostra(x,cx[1],cx[2],cx[3],cx[4]);
    clrscr;
    textcolor(white);
    writeln('Introdurre legge di variazione dell'' ordinata del baricentro');
    textcolor(7);
    mostra(y,cy[1],cy[2],cy[3],cy[4]);
    clrscr;
    textcolor(white);
    writeln('Introdurre legge di variazione della quota del baricentro');
    textcolor(7);
    mostra(z,cz[1],cz[2],cz[3],cz[4]);
    clrscr;
  end;
end;

procedure prep(gradi:Tgradi;t:real;var ang:angoli);
begin
  with gradi,ang do               {Precalcola il valore delle funz.      }
  begin                           {trigonometriche degli angoli di Eulero}
    cosfi:=cos(calc(fi,t,cf));
    senfi:=sin(calc(fi,t,cf));
    costeta:=cos(calc(teta,t,ct));
    senteta:=sin(calc(teta,t,ct));
    coscxi:=cos(calc(cxi,t,ci));
    sencxi:=sin(calc(cxi,t,ci));
  end;
end;

procedure Tpr(ang:angoli;var A:Rcoeff);
begin                                     {Matrice di trasformazione dal  }
  with ang do                             {sistema fisso a quello solidale}
  begin
    A[1,1]:=(cosfi*coscxi-senfi*sencxi*costeta);
    A[1,2]:=(coscxi*senfi+sencxi*costeta*cosfi);
    A[1,3]:=sencxi*senteta;
    A[2,1]:=(-cosfi*sencxi-senfi*coscxi*costeta);
    A[2,2]:=(-sencxi*senfi+coscxi*cosfi*costeta);
    A[2,3]:=coscxi*senteta;
    A[3,1]:=senteta*senfi;
    A[3,2]:=-senteta*cosfi;
    A[3,3]:=costeta;
  end
end;

procedure transf(A:Rcoeff;Pin:Punto3d;var Pfin:Punto3d);
begin
  with Pin do                          {Trasformazione da fisso a solidale}
  begin
    Pfin.x:=x*A[1,1]+y*A[1,2]+z*A[1,3];
    Pfin.y:=x*A[2,1]+y*A[2,2]+z*A[2,3];
    Pfin.z:=x*A[3,1]+y*A[3,2]+z*A[3,3];
  end;
end;

procedure rotosol(PA,New:Vpunt;grad:Tgradi;t:real);
var Vp:Vpunt;
    A:Rcoeff;
    Ang:angoli;
begin
  Vp:=PA;
  prep(grad,t,Ang);
  tpr(Ang,A);
  while Vp<>nil do
  begin
    transf(A,Vp^.Vcoord,New^.Vcoord);
    Vp:=Vp^.Vsucc;
    New:=New^.Vsucc;
  end;
end;

procedure transf2(A:Rcoeff;Pin:Punto3d;var Pfin:Punto3d);
begin
  with Pin do                         {Trasforamzione da solidale a fisso}
  begin
    Pfin.x:=x*A[1,1]+y*A[2,1]+z*A[3,1];
    Pfin.y:=x*A[1,2]+y*A[2,2]+z*A[3,2];
    Pfin.z:=x*A[1,3]+y*A[2,3]+z*A[3,3];
  end;
end;

procedure rotosol2(PA,New:Vpunt;grad:Tgradi;t:real);
var Vp:Vpunt;
    A:Rcoeff;                  {Rotazione del solido dei tre angoli}
    Ang:angoli;                {di Eulero                          }
begin
  Vp:=PA;
  prep(grad,t,Ang);
  tpr(Ang,A);
  while Vp<>nil do
  begin
    transf2(A,Vp^.Vcoord,New^.Vcoord);
    Vp:=Vp^.Vsucc;
    New:=New^.Vsucc;
  end;
end;

procedure trasla(var Bar:Punto3d;grad:Tgradi;t:real);
begin
  with grad do                  {Traslazione origine solidale}
  begin
    Bar.x:=calc(x,t,cx);
    Bar.y:=calc(y,t,cy);
    Bar.z:=calc(z,t,cz);
  end;
end;

procedure rototrasla (var Bar:Punto3d;PA,New:Vpunt;t:real;grad:Tgradi);
begin
    rotosol2(PA,New,grad,t);
    trasla(Bar,grad,t);
end;

procedure prosp(dist,quote:real;Pin:Punto3D;var Pfin:Punto2D);
const retro=105;
      giu=140;
var xtemp,ytemp,scala:integer;
    scalax,scalay:real;           {Esegue la proiezione prospettica }
begin                             {di un punto dello spazio posto   }
  scala:=15;                      {dietro il quadro di proiezione;  }
  scalax:=scala;                  {il centro di proiezione  C, con }
  scalay:=scalax*corr;            {C=(0,dist,quote)                 }
  Xtemp:=GetmaxX div 2;
  Ytemp:=GetmaxY;
  Pin.y:=Pin.y+retro;
  Pin.z:=Pin.z-giu;
  with Pin,Pfin do
  begin
    xs:=Xtemp+round(((dist-y)*x/y+x)*scalax);
    ys:=Ytemp-round(((dist-y)*(z-quote)/y+z)*scalay);
  end
end;

procedure deriva (grad:Tgradi;var der:Tgradi);
                                  {Precalcola le derivate delle sei}
                                  {funzioni del moto               }

procedure singola(ch:char;c:Konst;var tipo:char;var d:Konst);
begin
  tipo:=ch;
  case ch of
  'L':begin
        d[1]:=c[1];
        d[2]:=0;
        d[3]:=0;
        d[4]:=0;
      end;
  'Q':begin
       d[1]:=c[1];
       d[2]:=c[2];
       d[3]:=0;
       d[4]:=0;
     end;
  'C','F':begin
            d[1]:=c[1];
            d[2]:=c[2];
            d[3]:=-c[1]*c[3];
            d[4]:=0;
          end;
  'N','E','S':begin
                d[1]:=c[1];
                d[2]:=c[2];
                d[3]:=c[1]*c[3];
                d[4]:=0;
              end;
  end;
end;

{corpo principale della procedura}
begin
  with grad do
  begin
    singola(x,cx,der.x,der.cx);
    singola(y,cy,der.y,der.cy);
    singola(z,cz,der.z,der.cz);
    singola(fi,cf,der.fi,der.cf);
    singola(teta,ct,der.teta,der.ct);
    singola(cxi,ci,der.cxi,der.ci);
  end;
end;

function ln1(t:real;c:Konst):real;
var den:real;
begin                        {Derivata del logaritmo naturale}
  den:=(c[1]*t+c[2]);
  if den=0 then den:=0.0001;
  ln1:=c[3]/den;
end;

function frazio1(t:real;c:konst):real;
var den:real;
begin                              {Derivata del rapporto}
  den:=sqr((c[1]*t+c[2]));
  if den=0 then den:=0.0001;
  frazio1:=c[3]/den;
end;

function calcder(t:real;ch:char;c:Konst):real;
begin
  case ch of                    {Seleziona la derivata}
  'L':calcder:=c[1];
  'Q':calcder:=linear(t,c[1],c[2]);
  'S':calcder:=cseno(t,c[1],c[2],c[3],c[4]);
  'C':calcder:=seno(t,c[1],c[2],c[3],c[4]);
  'E':calcder:=esp(t,c[1],c[2],c[3],c[4]);
  'N':calcder:=ln1(t,c);
  'F':calcder:=frazio1(t,c);
  end;
end;

procedure prepder (t:real;der:Tgradi;var pri:prime);
begin
  with der,pri do           {Precalcola le derivate delle sei funzioni}
  begin
    x1:=calcder(t,x,cx);
    y1:=calcder(t,y,cy);
    z1:=calcder(t,z,cz);
    fi1:=calcder(t,fi,cf);
    teta1:=calcder(t,teta,ct);
    cxi1:=calcder(t,cxi,ci);
  end;
end;

function checktrasla(grad:Tgradi):boolean;
var der:Tgradi;
begin                                {Controlla se il moto  una traslazione}
  deriva(grad,der);
  with der do
  checktrasla:=zeri(fi,cf) and zeri(teta,ct) and zeri(cxi,ci);
end;

function check (bhc:char;Bar:Punto3d):real;
begin
  if bch='S' then check:=qpiano
             else check:=Bar.z;
end;

procedure omega (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;var p3d,q3d:punto3D);
var ang:angoli;
    pri:Prime;
    fatt1,fatt2,fatt3,lambda1,lambda2,w2,rw,aus:real;
    w:tre;
    i:integer;                  {Determina l'asse istantaneo di moto}
begin                           {nel sistema fisso                  }
  prepder(t,der,pri);
  prep(grad,t,ang);
  with pri,ang do
  begin
    fatt1:=fi1*sencxi*senteta+teta1*coscxi;
    fatt2:=fi1*coscxi*senteta-teta1*sencxi;
    fatt3:=fi1*costeta+cxi1;
    w[1]:=(coscxi*cosfi-senfi*sencxi*costeta)*fatt1+
          (-sencxi*cosfi-senfi*coscxi*costeta)*fatt2+senteta*senfi*fatt3;
    w[2]:=(coscxi*senfi+sencxi*costeta*cosfi)*fatt1+
          (-sencxi*senfi+coscxi*cosfi*costeta)*fatt2-senteta*cosfi*fatt3;
    w[3]:=(sencxi*senteta)*fatt1+coscxi*senteta*fatt2+costeta*fatt3;
  end;
  with pri,grad do
  begin
    if w[3]=0 then w[3]:=0.0001;
    w2:=w[1]*w[1]+w[2]*w[2]+w[3]*w[3];
    rw:=sqrt(w2);
    if (abs(w[3])<0.001) then
    begin
      if (abs(w[1])>=0.001) then
      begin
        Aus:=Bar.x;
        lambda1:=(Aus-(w[2]*y1-w[3]*x1)/w2-calc(z,t,cz))/w[1]
      end
      else
      begin
        if w[2]=0 then w[2]:=0.0001;
        Aus:=Bar.y;
        lambda1:=(Aus-(w[3]*y1-w[1]*x1)/w2-calc(z,t,cz))/w[2];
      end
    end
    else
    lambda1:=(q-(w[1]*y1-w[2]*x1)/w2-calc(z,t,cz))/w[3];
    lambda2:=d/rw+lambda1;
    P3d.x:=(w[2]*z1-w[3]*y1)/w2+lambda1*w[1]+calc(x,t,cx);
    P3d.y:=(w[3]*x1-w[1]*z1)/w2+lambda1*w[2]+calc(y,t,cy);
    P3d.z:=(w[1]*y1-w[2]*x1)/w2+lambda1*w[3]+calc(z,t,cz);
    Q3d.x:=(w[2]*z1-w[3]*y1)/w2+lambda2*w[1]+calc(x,t,cx);
    Q3d.y:=(w[3]*x1-w[1]*z1)/w2+lambda2*w[2]+calc(y,t,cy);
    Q3d.z:=(w[1]*y1-w[2]*x1)/w2+lambda2*w[3]+calc(z,t,cz);
  end;
end;

procedure omegas (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;var p3d,q3d:punto3D);
var ang:angoli;
    pri:Prime;
    fatt1,fatt2,fatt3,lambda1,lambda2,w2,rw,aus:real;
    w:tre;
    i:integer;                       {Determina l'asse istantaneo di}
begin                                {moto nel sistema solidale     }
  prepder(t,der,pri);
  prep(grad,t,ang);
  with pri,ang do
  begin
    fatt1:=fi1*sencxi*senteta+teta1*coscxi;
    fatt2:=fi1*coscxi*senteta-teta1*sencxi;
    fatt3:=fi1*costeta+cxi1;
    w[1]:=(coscxi*cosfi-senfi*sencxi*costeta)*fatt1+
          (-sencxi*cosfi-senfi*coscxi*costeta)*fatt2+senteta*senfi*fatt3;
    w[2]:=(coscxi*senfi+sencxi*costeta*cosfi)*fatt1+
          (-sencxi*senfi+coscxi*cosfi*costeta)*fatt2-senteta*cosfi*fatt3;
    w[3]:=(sencxi*senteta)*fatt1+coscxi*senteta*fatt2+costeta*fatt3;
  end;
  with pri,grad do
  begin
    if w[3]=0 then w[3]:=0.0001;
    w2:=w[1]*w[1]+w[2]*w[2]+w[3]*w[3];
    rw:=sqrt(w2);
    if (abs(w[3])<0.001) then
    begin
      if (abs(w[1])>=0.001) then
      begin
        aus:=Bar.x;
        lambda1:=(q-(w[2]*y1-w[3]*x1)/w2)/w[1]
      end
      else
      begin
        if w[2]=0 then w[2]:=0.0001;
        aus:=Bar.y;
        lambda1:=(q-(w[3]*y1-w[1]*x1)/w2)/w[2];
      end
    end
    else
    lambda1:=(q-(w[1]*y1-w[2]*x1)/w2)/w[3];
    lambda2:=d/rw+lambda1;
    P3d.x:=(w[2]*z1-w[3]*y1)/w2+lambda1*w[1];
    P3d.y:=(w[3]*x1-w[1]*z1)/w2+lambda1*w[2];
    P3d.z:=(w[1]*y1-w[2]*x1)/w2+lambda1*w[3];
    Q3d.x:=(w[2]*z1-w[3]*y1)/w2+lambda2*w[1];
    Q3d.y:=(w[3]*x1-w[1]*z1)/w2+lambda2*w[2];
    Q3d.z:=(w[1]*y1-w[2]*x1)/w2+lambda2*w[3];
  end;
end;

procedure omega1 (t,q:real;grad,der:Tgradi;var p3d:punto3D);
var ang:angoli;
    pri:Prime;
    fatt1,fatt2,fatt3,lambda1,lambda2,w2:real;
    w:tre;
    i:integer;
begin                           {Punto di intersezione dell'asse di}
  prepder(t,der,pri);           {moto con un piano orizzontale nel }
  prep(grad,t,ang);             {sistema fisso                     }
  with pri,ang do
  begin
    fatt1:=fi1*sencxi*senteta+teta1*coscxi;
    fatt2:=fi1*coscxi*senteta-teta1*sencxi;
    fatt3:=fi1*costeta+cxi1;
    w[1]:=(coscxi*cosfi-senfi*sencxi*costeta)*fatt1+
          (-sencxi*cosfi-senfi*coscxi*costeta)*fatt2+senteta*senfi*fatt3;
    w[2]:=(coscxi*senfi+sencxi*costeta*cosfi)*fatt1+
          (-sencxi*senfi+coscxi*cosfi*costeta)*fatt2-senteta*cosfi*fatt3;
    w[3]:=(sencxi*senteta)*fatt1+coscxi*senteta*fatt2+costeta*fatt3;
  end;
  with pri,grad do
  begin
    if w[3]=0 then w[3]:=0.0001;
    w2:=w[1]*w[1]+w[2]*w[2]+w[3]*w[3];
    lambda1:=(q-(w[1]*y1-w[2]*x1)/w2-calc(z,t,cz))/w[3];
    P3d.x:=(w[2]*z1-w[3]*y1)/w2+lambda1*w[1]+calc(x,t,cx);
    P3d.y:=(w[3]*x1-w[1]*z1)/w2+lambda1*w[2]+calc(y,t,cy);
    P3d.z:=(w[1]*y1-w[2]*x1)/w2+lambda1*w[3]+calc(z,t,cz);
  end;
end;

procedure omega2a (t,q:real;grad,der:Tgradi;var p3d:punto3D);
var ang:angoli;
    pri:Prime;
    fatt1,fatt2,fatt3,lambda1,lambda2,w2:real;
    w:tre;
    i:integer;                  {Come omega1, ma riferito}
begin                           {al sistema solidale     }
  prepder(t,der,pri);
  prep(grad,t,ang);
  with pri,ang do
  begin
    fatt1:=fi1*sencxi*senteta+teta1*coscxi;
    fatt2:=fi1*coscxi*senteta-teta1*sencxi;
    fatt3:=fi1*costeta+cxi1;
    w[1]:=(coscxi*cosfi-senfi*sencxi*costeta)*fatt1+
          (-sencxi*cosfi-senfi*coscxi*costeta)*fatt2+senteta*senfi*fatt3;
    w[2]:=(coscxi*senfi+sencxi*costeta*cosfi)*fatt1+
          (-sencxi*senfi+coscxi*cosfi*costeta)*fatt2-senteta*cosfi*fatt3;
    w[3]:=(sencxi*senteta)*fatt1+coscxi*senteta*fatt2+costeta*fatt3;
  end;
  with pri,grad do
  begin
    if w[3]=0 then w[3]:=0.0001;
    w2:=w[1]*w[1]+w[2]*w[2]+w[3]*w[3];
    lambda1:=(q-(w[1]*y1-w[2]*x1)/w2)/w[3];
    P3d.x:=(w[2]*z1-w[3]*y1)/w2+lambda1*w[1];
    P3d.y:=(w[3]*x1-w[1]*z1)/w2+lambda1*w[2];
    P3d.z:=(w[1]*y1-w[2]*x1)/w2+lambda1*w[3];
  end;
end;

procedure omega2 (t,q:real;grad,der:Tgradi;var p3d:punto3D);
var A:Rcoeff;
    Ang:Angoli;
begin                         {Usa omega2a per trovare i punti della}
  prep(grad,t,Ang);           {solidale                             }
  tpr(Ang,A);
  omega2a(t,q,grad,der,p3d);
  transf(A,p3d,p3d);
end;

procedure prospf(dist,quote:real;Bar:Punto3d;Pin:Punto3D;var Pfin:Punto2D);
const retro=105;
      giu=140;
var xtemp,ytemp,scala:integer;
    scalax,scalay:real;
begin
  scala:=15;                    {Come prosp, ma riferita al sistema fisso}
  scalax:=scala;
  scalay:=scalax*corr;
  Xtemp:=GetmaxX div 2;
  Ytemp:=GetmaxY;
  with Pin do
  begin
    x:=x+Bar.x;
    y:=y+Bar.y+retro;
    z:=z+Bar.z-giu;
  end;
  with Pin,Pfin do
  begin
    xs:=Xtemp+round(((dist-y)*x/y+x)*scalax);
    ys:=Ytemp-round(((dist-y)*(z-quote)/y+z)*scalay);
  end
end;

function sign(r:real):integer;
begin
  if r>0 then sign:=1
         else if r=0 then sign:=0
                     else sign:=-1;
end;

procedure baric(PA:Vpunt;var p3d:Punto3d);
var sx,sy,sz:real;
    n:integer;                  {Calcola il baricentro del solido}
begin
  assoluto:=false;
  sx:=0;
  sy:=0;
  sz:=0;
  n:=0;
  while PA<>nil do
  begin
    n:=n+1;
    sx:=sx+PA^.Vcoord.x;
    sy:=sy+PA^.Vcoord.y;
    sz:=sz+PA^.Vcoord.z;
    PA:=PA^.Vsucc;
  end;
  with p3d do
  begin
    x:=sx/n;
    y:=sy/n;
    z:=sz/n;
  end
end;

procedure cambia(PA:Vpunt;Bar:Punto3d);
begin
  while PA<>nil do
  with PA^ do                    {Riferisce le coord. del solido al-}
  begin                          {l'origine solidale                }
    Vcoord.x:=Vcoord.x-Bar.x;
    Vcoord.y:=Vcoord.y-Bar.y;
    Vcoord.z:=Vcoord.z-Bar.z;
    PA:=PA^.Vsucc;
  end;
end;

procedure torna(PA:Vpunt;Bar:Punto3d);
begin
  while PA<>nil do
  with PA^ do                    {Riferisce le coord. del solido al-}
  begin                          {l'origine fissa                   }
    Vcoord.x:=Vcoord.x+Bar.x;
    Vcoord.y:=Vcoord.y+Bar.y;
    Vcoord.z:=Vcoord.z+Bar.z;
    PA:=PA^.Vsucc;
  end;
end;

procedure libera(var PA:Vpunt);
var Vp:Vpunt;

procedure togli(var Link:Lpunt);
var Lp:Lpunt;
begin                     {Elimina i legami di un singolo}
  while Link<>nil do      {vertice dalla memoria         } 
  begin
    Lp:=Link;
    Link:=Lp^.Lsucc;
    dispose(Lp);
  end;
end;

{corpo principale della procedura}
begin
  while PA<>nil do            {Elimina il solido rappresentato}
  begin                       {a partire da PA dalla memoria  }
    Vp:=PA;
    togli(Vp^.Link);
    PA:=Vp^.Vsucc;
    dispose(Vp);
  end;
end;

procedure LVwrite(var PA:Vpunt;P3D:Punto3D);
var Vp:Vpunt;
begin
    new(Vp);                    {Aggiorna la lista dei vertici     }
    Vp^.Link:=nil;              {con il punto dello spazio P3D,    }
    Vp^.Vcoord:=P3D;            {ponendo a nil la lista dei legami }
    Vp^.Vsucc:=PA;
    Vp^.Vcod:=code;
    PA:=Vp;
    code:=code+1;
end;

procedure LVwrite2(var PA:Vpunt;P3D:Punto3D;codix:integer);
var Vp:Vpunt;
begin
    new(Vp);               {Lvwrite usata per la copia del solido}
    Vp^.Link:=nil;
    Vp^.Vcoord:=P3D;
    Vp^.Vsucc:=PA;
    Vp^.Vcod:=codix;
    PA:=Vp;
end;

procedure estrai (P3D:Punto3d;PA:Vpunt;var Vp:Vpunt;var Err:boolean);
var j:integer;
begin                              
  Vp:=PA;
  while (Vp<>nil) and ((Vp^.Vcoord.x<>P3D.x)
   or (Vp^.Vcoord.y<>P3D.y) or (Vp^.Vcoord.z<>P3d.z))  do
    Vp:=Vp^.Vsucc;
  if Vp=nil then Err:=true                   {Istanzia Vp al puntatore       }
            else Err:=false;                 {che individua P3D, punto dello }
end;                                         {spazio, Err a true se non lo   }
                                             {trova nella lista corrente     }

procedure estrai2 (codix:integer;PA:Vpunt;var Vp:Vpunt;var Err:boolean);
var j:integer;
begin                              
  Vp:=PA;                                     {Idem, ma pi efficiente e }
  while (Vp<>nil) and (Vp^.Vcod<>codix) do    {con meno controlli        }
    Vp:=Vp^.Vsucc;
  if Vp=nil then Err:=true
            else Err:=false;
end;

procedure estrai3 (codix:integer;PA:Vpunt;var Vp:Vpunt);
var j:integer;
begin                                         {Ancora pi efficente}
  Vp:=PA;
  while (Vp<>nil) and (Vp^.Vcod<>codix) do
    Vp:=Vp^.Vsucc;
end;

procedure LLwrite(Var Link:Lpunt;Vp:Vpunt);
var Lp:Lpunt;
begin                                {Aggiorna la lista dei legami di un   }
  new(Lp);                           {vertice con il puntatore ad un altro }
  Lp^.Rif:=Vp;                       {vertice (estremo)                    }
  Lp^.Lsucc:=Link;
  Link:=Lp;
end;

procedure unione3(Old:Vpunt;modif:Lpunt;var Link:Lpunt);
var Err:boolean;
    Lp:Lpunt;
    Vp,Attp:Vpunt;
    codix:integer;             {Crea i legami nella copia del solido}
begin
  while modif<>nil do
  begin
    Vp:=modif^.Rif;
    codix:=Vp^.Vcod;
    estrai2(codix,Old,Attp,Err);
    LLwrite(Link,Attp);
    modif:=modif^.Lsucc;
  end;
end;

procedure copia(PA:Vpunt;var Old:Vpunt);
var Vp,Op:Vpunt;
    Lp:Lpunt;
    Err:boolean;
begin                            {Esegue la copia di un solido}
  Old:=nil;                      {creando una nuova struttura }
  Vp:=PA;
  while Vp<>nil do
  begin
    LVwrite2(Old,Vp^.Vcoord,Vp^.Vcod);
    Vp:=Vp^.Vsucc;
  end;
  Vp:=PA;
  while Vp<>nil do
  begin
    estrai2(Vp^.Vcod,Old,Op,Err);
    unione3(Old,Vp^.Link,Op^.Link);
    Vp:=Vp^.Vsucc;
  end;
end;

procedure plan(scala:integer;p3d:Punto3D;var p2d:Punto2D);
var Xtemp,Ytemp:integer;
    scalax,scalay:real;          {Esegue la proiezione di un punto }
begin                            {dello spazio sul piano di terra  }
  Xtemp:=GetmaxX div 2;
  Ytemp:=GetmaxY;
  with p3d,p2d do
  begin
    xs:=Xtemp+round(x*scala);
    ys:=Ytemp-round(y*scala*corr);
  end;
end;

procedure planf(Bar:Punto3d;scala:integer;p3d:Punto3D;var p2d:Punto2D);
var Xtemp,Ytemp:integer;
    scalax,scalay:real;          {Esegue la proiezione di un punto }
begin                            {dello spazio sul piano di terra  }
  with P3d do                    {in coordinate fisse              }
  begin
    x:=x+Bar.x;
    y:=y+Bar.y;
  end;
  Xtemp:=GetmaxX div 2;
  Ytemp:=GetmaxY;
  with p3d,p2d do
  begin
    xs:=Xtemp+round(x*scala);
    ys:=Ytemp-round(y*scala*corr);
  end;
end;

procedure asson(scala:integer;p3d:Punto3D;var p2d:Punto2D);
var Xtemp,Ytemp:integer;
    scalay:real;
    rady:real;                   {Esegue la proiezione in  }
begin                            {assonometria cavaliera   }
  Xtemp:=GetmaxX div 3;          {sul piano y=0 di un punto}
  Ytemp:=GetmaxY;                {dello spazio             }
  scalay:=scala*corr;
  with p3d,p2d do
  begin
    rady:=rad*y;
    xs:=Xtemp+round((x+rady)*scala);
    ys:=Ytemp-round((z+rady)*scalay);
  end;
end;

procedure assonf(Bar:Punto3d;scala:integer;p3d:Punto3D;var p2d:Punto2D);
var Xtemp,Ytemp:integer;
    scalay:real;
    rady:real;                   {esegue la proiezione in  }
begin                            {assonometria cavaliera   }
  Xtemp:=GetmaxX div 3;          {sul piano y=0 di un punto}
  Ytemp:=GetmaxY;                {dello spazio  nel sistema}
  scalay:=scala*corr;            {fisso                    }
  with p3d do
  begin
    x:=x+Bar.x;
    y:=y+Bar.y;
    z:=z+Bar.z;
  end;
  with p3d,p2d do
  begin
    rady:=rad*y;
    xs:=Xtemp+round((x+rady)*scala);
    ys:=Ytemp-round((z+rady)*scalay);
  end;
end;

procedure asse (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;scala:integer);
var p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;                      {Disegna l'asse di moto}
begin                                     {nel sistema fisso in  }
  omega(Bar,t,d,q,grad,der,p3d,q3d);      {assonometria          }
  asson(scala,p3d,p2d);
  asson(scala,q3d,q2d);
  line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
end;

procedure asse2 (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;scala:integer);
var p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;                      {Disegna l'asse di moto}
begin                                     {nel sistema fisso in  }
  if not traslazione then                 {assonometria con gli  }
  begin                                   {estremi evidenziati   }
    omega(Bar,t,d,q,grad,der,p3d,q3d);
    asson(scala,p3d,p2d);
    asson(scala,q3d,q2d);
    circle(p2d.xs,p2d.ys,3);
    circle(q2d.xs,q2d.ys,3);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
  end;
end;

procedure sist(O,P:Punto3d;var Q:Punto3d);
begin
  Q.x:=P.x+O.x;
  Q.y:=P.y+O.y;
  Q.z:=P.z;
end;

procedure asses (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;scala:integer);
var O,p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;
    Ang:Angoli;
    A:Rcoeff;                          {Disegna l'asse di moto }
                                       {nel sistema solidale in}
begin                                  {assonometria           }
  O.x:=20;
  O.y:=20;
  prep(grad,t,Ang);
  tpr(Ang,A);
  omegas(Bar,t,d,q,grad,der,p3d,q3d);
  transf(A,p3d,p3d);
  transf(A,q3d,q3d);
  sist(O,p3d,p3d);
  sist(O,q3d,q3d);
  asson(scala,p3d,p2d);
  asson(scala,q3d,q2d);
  line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
end;

procedure asseps (Bar:Punto3d;t,d,q:real;grad,der:Tgradi);
var O,p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;
    Ang:Angoli;
    A:Rcoeff;                         {Asse solidale in prospettiva}

begin
  O.x:=0;
  O.y:=20;
  prep(grad,t,Ang);
  tpr(Ang,A);
  omegas(Bar,t,d,q,grad,der,p3d,q3d);
  transf(A,p3d,p3d);
  transf(A,q3d,q3d);
  sist(O,p3d,p3d);
  sist(O,q3d,q3d);
  prosp(distance,quote,p3d,p2d);
  prosp(distance,quote,q3d,q2d);
  line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
end;

procedure sis(O,P:punto2d;var Q:punto2d);
begin
  Q.xs:=P.xs;
  Q.ys:=P.ys-O.ys;
end;

procedure assels (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;scala:integer);
var p3d,q3d:Punto3d;
    O,p2d,q2d:Punto2d;
    A:Rcoeff;                           {Asse solidale in pianta}
    Ang:Angoli;

begin
  O.ys:=getmaxy div 2;
  prep(grad,t,Ang);
  tpr(Ang,A);
  omegas(Bar,t,d,q,grad,der,p3d,q3d);
  transf(A,p3d,p3d);
  transf(A,q3d,q3d);
  plan(scala,p3d,p2d);
  plan(scala,q3d,q2d);
  sis(O,p2d,p2d);
  sis(O,q2d,q2d);
  line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
end;

procedure assel (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;scala:integer);
var p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;                      {Asse fisso in pianta}
begin
  omega(Bar,t,d,q,grad,der,p3d,q3d);
  plan(scala,p3d,p2d);
  plan(scala,q3d,q2d);
  line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
end;

procedure assel2 (Bar:Punto3d;t,d,q:real;grad,der:Tgradi;scala:integer);
var p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;                      {Asse fisso in pianta   }
begin                                     {con estremi evidenziati}
  if not traslazione then
  begin
    omega(Bar,t,d,q,grad,der,p3d,q3d);
    plan(scala,p3d,p2d);
    plan(scala,q3d,q2d);
    circle(p2d.xs,p2d.ys,3);
    circle(q2d.xs,q2d.ys,3);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
  end;
end;

procedure assep (Bar:punto3d;t,d,q:real;grad,der:Tgradi);
var p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;                    {Asse fisso in prospettiva}
begin
  omega(Bar,t,d,q,grad,der,p3d,q3d);
  prosp(distance,quote,p3d,p2d);
  prosp(distance,quote,q3d,q2d);
  line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
end;

procedure assep2 (Bar:punto3d;t,d,q:real;grad,der:Tgradi);
var p3d,q3d:Punto3d;
    p2d,q2d:Punto2d;                    {Asse fisso in prospettiva  }
begin                                   {con gli estremi evidenziati}
  if not traslazione then
  begin
    omega(Bar,t,d,q,grad,der,p3d,q3d);
    prosp(distance,quote,p3d,p2d);
    prosp(distance,quote,q3d,q2d);
    circle(p2d.xs,p2d.ys,3);
    circle(q2d.xs,q2d.ys,3);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
  end;
end;

procedure disegna3 (scala:integer;p2d:Punto2D;Link:Lpunt);
var Lp:Lpunt;
    Vp:Vpunt;                    {Traccia i segmenti che congiungono }
    q3D:Punto3D;                 {p2d con i vertici contenuti nella  }
    q2D:Punto2D;                 {lista dei legami di p3d, la retro- }
begin                            {immagine di p2d nella proiezione   }
  Lp:=Link;                      {assonometrica                      }
  while (Lp<>nil) do
  begin
    Vp:=Lp^.Rif;
    q3D:=Vp^.Vcoord;
    asson(scala,q3D,q2D);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    Lp:=Lp^.Lsucc;
  end;
end;

procedure disegna3f (Bar:Punto3d;scala:integer;p2d:Punto2D;Link:Lpunt);
var Lp:Lpunt;
    Vp:Vpunt;                    {Traccia i segmenti che congiungono }
    q3D:Punto3D;                 {p2d con i vertici contenuti nella  }
    q2D:Punto2D;                 {lista dei legami di p3d, la retro- }
begin                            {immagine di p2d nella proiezione   }
  Lp:=Link;                      {assonometrica nel sistema fisso    }
  while (Lp<>nil) do
  begin
    Vp:=Lp^.Rif;
    q3D:=Vp^.Vcoord;
    assonf(Bar,scala,q3D,q2D);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    Lp:=Lp^.Lsucc;
  end;
end;

procedure caval(scala:integer;PA:Vpunt);
var p3D,q3D:Punto3D;
    p2D,q2D:Punto2D;
    Vp:Vpunt;                    {Esegue la proiezione in cavaliera   }
    Lp:Lpunt;                    {del solido memorizzato a partire    }
begin                            {dal puntatore PA                    }
  Vp:=PA;
  while (Vp<>nil) do
  begin
    asson(scala,Vp^.Vcoord,p2D);
    disegna3(scala,p2D,Vp^.Link);
    Vp:=Vp^.Vsucc;
  end;
end;

procedure cavalf(Bar:Punto3d;scala:integer;PA:Vpunt);
var p3D,q3D:Punto3D;
    p2D,q2D:Punto2D;
    Vp:Vpunt;                    {Esegue la proiezione in cavaliera   }
    Lp:Lpunt;                    {del solido memorizzato a partire    }
begin                            {dal puntatore PA nel sistema fisso  }
  Vp:=PA;
  while (Vp<>nil) do
  begin
    assonf(Bar,scala,Vp^.Vcoord,p2D);
    disegna3f(Bar,scala,p2D,Vp^.Link);
    Vp:=Vp^.Vsucc;
  end;
end;

procedure disegna2 (scala:integer;p2d:Punto2D;Link:Lpunt);
var Lp:Lpunt;
    Vp:Vpunt;                    {Traccia i segmenti che congiungono }
    q3D:Punto3D;                 {p2d con i vertici contenuti nella  }
    q2D:Punto2D;                 {lista dei legami di p3d, la retro- }
begin                            {immagine di p2d nella proiezione   }
  Lp:=Link;                      {in pianta                          }
  while (Lp<>nil) do
  begin
    Vp:=Lp^.Rif;
    q3D:=Vp^.Vcoord;
    plan(scala,q3D,q2D);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    Lp:=Lp^.Lsucc;
  end;
end;

procedure disegna2f (Bar:Punto3d;scala:integer;p2d:Punto2D;Link:Lpunt);
var Lp:Lpunt;
    Vp:Vpunt;                    {Traccia i segmenti che congiungono }
    q3D:Punto3D;                 {p2d con i vertici contenuti nella  }
    q2D:Punto2D;                 {lista dei legami di p3d, la retro- }
begin                            {immagine di p2d nella proiezione   }
  Lp:=Link;                      {in pianta nel sistema fisso        }
  while (Lp<>nil) do
  begin
    Vp:=Lp^.Rif;
    q3D:=Vp^.Vcoord;
    planf(Bar,scala,q3D,q2D);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    Lp:=Lp^.Lsucc;
  end;
end;

procedure pianta(PA:Vpunt;scala:integer);
var p3D,q3D:Punto3D;
    p2D,q2D:Punto2D;
    Vp:Vpunt;                    {Esegue la proiezione in pianta   }
    Lp:Lpunt;                    {del solido memorizzato a partire }
begin                            {dal puntatore PA                 }
  Vp:=PA;
  while (Vp<>nil) do
  begin
    plan(scala,Vp^.Vcoord,p2D);
    disegna2(scala,p2D,Vp^.Link);
    Vp:=Vp^.Vsucc;
  end;
end;

procedure piantaf(Bar:Punto3d;PA:Vpunt;scala:integer);
var p3D,q3D:Punto3D;
    p2D,q2D:Punto2D;
    Vp:Vpunt;                    {Esegue la proiezione in pianta   }
    Lp:Lpunt;                    {del solido memorizzato a partire }
begin                            {dal puntatore PA nel sist. fisso }
  Vp:=PA;
  while (Vp<>nil) do
  begin
    planf(Bar,scala,Vp^.Vcoord,p2D);
    disegna2f(Bar,scala,p2D,Vp^.Link);
    Vp:=Vp^.Vsucc;
  end;
end;

procedure readpoint(var x,y,z:real);
var xs,ys:integer;
    Err:boolean;                 {Legge un punto 3d prevenendo gli errori}
begin
  {$I-}
  xs:=wherex; ys:=wherey;
  repeat
    readln(x,y,z);
    Err:=ioresult<>0;
    if Err then
    begin
      gotoxy(xs,ys);
      write(#7,'  ':35);
      gotoxy(xs,ys);
    end;
  until not Err;
  {$I+}
end;

procedure unione (var Link:Lpunt;m:integer);
var P:Lpunt;
    i:integer;                   {Crea la lista di m legami }
    P3D:Punto3D;                 {di un singolo vertice     }
    Vp:Vpunt;
    Err:boolean;
begin
  for i:=1 to m do
  begin
    repeat
      write('Immettere coordinate dell''estremo n',i,'--> ');
      with P3D do readpoint(x,y,z);
      estrai(P3d,Pa,Vp,Err);
      if Err then
      begin
        gotoxy(1,wherey-1);
        write(#7);
        write('Estremo errato !                                  ');
        delay(1000);
        gotoxy(1,wherey);
      end;
    until not Err;
    LLwrite(Link,Vp);
  end;
end;

procedure spigoli (var PA:Vpunt;n:integer);
var Vp:Vpunt;
    i,j,m:integer;
    P3d:Punto3D;                 {Crea la lista dei legami per    }
    ch:char;                     {tutti i vertici a cui si voglia }
    Err:boolean;                 {congiungere un estremo          }

procedure scrivi(PA:Vpunt;P:punto3d);
var x,y,i:integer;
    p3d:Punto3d;
begin
  i:=1;
  y:=wherey;
  writeln('Lista vertici possibili:');
  textcolor(white);
  while PA<>nil do
  begin
    p3d:=PA^.Vcoord;
    if i<=4 then
            gotoxy((i-1)*18+1,wherey)
            else
            begin
              i:=1;
              gotoxy((i-1)*18+1,wherey+1);
            end;
    if (p.x<>p3d.x) or (p.y<>p3d.y) or (p.z<>p3d.z) then
    begin
      with p3d do
      write('(',x:3:0,',',y:3:0,',',z:3:0,')');
    end
    else i:=i-1;
    PA:=PA^.Vsucc;
    i:=i+1;
  end;
  writeln;
  textcolor(7);
end;

begin
  clrscr;
  ch:='N';
  i:=1;
  writeln(' ':20,'Creazione degli spigoli');writeln;
  repeat
    repeat
      write('Immettere coordinate del vertice n',i,'--> ');
      with P3D do readpoint(x,y,z);
      estrai(P3d,Pa,Vp,Err);
      if Err then
      begin
        gotoxy(1,wherey-1);
        write(#7);
        write('Vertice errato !                                  ');
        delay(1000);
        gotoxy(1,wherey);
      end;
    until not Err;
    gotoxy(1,wherey-1);
    write('Con quanti vertici  unito il vertice ');
    with P3D do write('(',x:4:0,',',y:4:0,',',z:4:0,') ? ');
    readint(m);
    if m>lunga(PA) then m:=lunga(PA)-1;
    scrivi(PA,p3d);
    unione(Vp^.Link,m);
    writeln;
    writeln('Fine lavoro ?(S/N)');
    ch:=UpCase(readkey);
    i:=i+1;
    clrscr;
  until ch='S';
end;


procedure immetti (var PA:Vpunt;var n:integer);
var Vp:Vpunt;
    i,j,nl:integer;           {Crea la lista che rappresenta in }
    P3D:Punto3D;              {memoria il solido (una coda)     }
    Err:boolean;
    xs,ys:integer;

function ce(PA:Vpunt;p3d:Punto3d;n:integer):boolean;
begin
  while (PA<>nil) and ((p3d.x<>PA^.Vcoord.x) or (p3d.y<>PA^.Vcoord.y) or
                       (p3d.z<>PA^.Vcoord.z)) do
  PA:=PA^.Vsucc;
  if (PA=nil) or (n=1)  then ce:=false
                        else ce:=true;
end;

begin
  clrscr;
  PA:=nil;
  write('Di quanti vertici  formato il solido ? ');readint(n);
  for i:=1 to n do
  begin
    write('Immettere vertice n',i,' --->');
    xs:=wherex; ys:=wherey;
    repeat
      with P3D do readpoint(x,y,z);
      Err:=ce(PA,p3d,i);
      if Err then
      begin
        gotoxy(xs,ys);
        write(#7,' ':40);
        gotoxy(xs,ys);
      end;
    until not Err;
    LVwrite(PA,P3D);
  end;
  spigoli(PA,n);
end;

procedure disegna(p2D:Punto2D;Link:Lpunt);
var Lp:Lpunt;
    Vp:Vpunt;                    {Traccia i segmenti che congiungono  }
    q3D:Punto3D;                 {p2d con i vertici contenuti nella   }
    q2D:Punto2D;                 {lista dei legami di p3d, la retro-  }
begin                            {immagine di p2d nella proiezione    }
  Lp:=Link;                      {prospettica                         }
  while (Lp<>nil) do
  begin
    Vp:=Lp^.Rif;
    q3D:=Vp^.Vcoord;
    prosp(distance,quote,q3D,q2D);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    Lp:=Lp^.Lsucc;
  end;
end;

procedure disegnaf(Bar:Punto3d;p2D:Punto2D;Link:Lpunt);
var Lp:Lpunt;
    Vp:Vpunt;                    {Traccia i segmenti che congiungono  }
    q3D:Punto3D;                 {p2d con i vertici contenuti nella   }
    q2D:Punto2D;                 {lista dei legami di p3d, la retro-  }
begin                            {immagine di p2d nella proiezione    }
  Lp:=Link;                      {prospettica nel sistema fisso       }
  while (Lp<>nil) do
  begin
    Vp:=Lp^.Rif;
    q3D:=Vp^.Vcoord;
    prospf(distance,quote,Bar,q3D,q2D);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    Lp:=Lp^.Lsucc;
  end;
end;

procedure visualizza(PA:Vpunt);
var p3D,q3D:Punto3D;
    p2D,q2D:Punto2D;             {Disegna il solido che  rappresentato }
    Vp:Vpunt;                    {in memoria a partire dal puntatore    }
    Lp:Lpunt;                    {PA in proiezione prospettica          }
begin
  Vp:=PA;
  while (Vp<>nil) do
  begin
    prosp(distance,quote,Vp^.Vcoord,p2D);
    disegna(p2D,Vp^.Link);
    Vp:=Vp^.Vsucc;
  end;
end;

procedure visualizzaf(Bar:Punto3d;PA:Vpunt);
var p3D,q3D:Punto3D;
    p2D,q2D:Punto2D;             {Disegna il solido che  rappresentato }
    Vp:Vpunt;                    {in memoria a partire dal puntatore    }
    Lp:Lpunt;                    {PA in proiezione prospettica nel      }
begin                            {sistema fisso                         }
  Vp:=PA;
  while (Vp<>nil) do
  begin
    prospf(distance,quote,Bar,Vp^.Vcoord,p2D);
    disegnaf(Bar,p2D,Vp^.Link);
    Vp:=Vp^.Vsucc;
  end;
end;

procedure unione2 (PA:Vpunt;var Link:Lpunt;m:integer);
var P:Lpunt;
    i:integer;                    {Come unione, ma leggendo}
    P3D:Punto3D;                  {da file di testo}
    Vp:Vpunt;
    Err:boolean;
begin
  for i:=1 to m do
  begin
    with P3D do readln(store,x,y,z);
    estrai(P3d,Pa,Vp,Err);
    LLwrite(Link,Vp);
  end;
end;

procedure leggi(var store:text;var PA:Vpunt);
var Vp:Vpunt;
    Lp:Lpunt;                    {Legge i dati relati ad un solido           }
    P3d:Punto3d;                 {da un file di testo con ext .DWG,          }
    i,j,n,m,num:integer;         {lo rapresenta in memoria a partire         }
    st:string[8];                {da PA. Sequenza nel file di testo:         }
    Err:boolean;                 {n dei vertici,n dei vertici legati,      }
begin                            {'vertice', coord. del vertice in questione,}
  reset(store);                  {n dei legami, estremi con cui  legato    }
  readln(store,n);               {(che devono essere estremi gi dichiarati).}
  PA:=nil;
  for i:=1 to n do
  begin
    with P3d do readln(store,x,y,z);
    LVwrite(PA,P3d);
  end;
  readln(store,num);
  for i:=1 to num do
  begin
    readln(store,st);
    if (st='vertice') and (not EOF) then
    begin
      with P3d do readln(store,x,y,z);
      estrai(P3d,PA,Vp,Err);
      readln(store,st);
      if (st='legami_') and (not EOF) then
      begin
        readln(store,m);
        unione2(PA,Vp^.Link,m);
      end;
    end;
  end;
  close(store);
end;

procedure leggifunc (var fun:text;Var Grad:Tgradi);
var ch:char;
    Err:boolean;                 {Legge 6 funzioni con relativi  }
    i:integer;                   {coefficenti da un file di testo}
    st:string;

procedure trova (var ch:char;var c:Konst);
var st:string;
    c1,c2,c3,c4:real;
begin
  readln(fun,st);
  if st='At+B' then
  begin
    ch:='L';
    readln(fun,c1);
    readln(fun,c2);
    c3:=0;
    c4:=0;
  end
  else if st='Asen(wt+f)+B' then
  begin
    ch:='S';
    readln(fun,c1);
    readln(fun,c2);
    readln(fun,c3);
    readln(fun,c4);
  end
  else if st='Acos(wt+f)+B' then
  begin
    ch:='C';
    readln(fun,c1);
    readln(fun,c2);
    readln(fun,c3);
    readln(fun,c4);
  end
  else if st='Aesp(wt+f)+B' then
  begin
    ch:='E';
    readln(fun,c1);
    readln(fun,c2);
    readln(fun,c3);
    readln(fun,c4);
  end
  else if st='Aln(wt+f)+B' then
  begin
    ch:='N';
    readln(fun,c1);
    readln(fun,c2);
    readln(fun,c3);
    readln(fun,c4);
  end
  else if st='At^2+Bt+C' then
  begin
    ch:='Q';
    readln(fun,c1);
    readln(fun,c2);
    readln(fun,c3);
    c4:=0;
  end
  else if st='A/(wt+f)+B' then
  begin
    ch:='F';
    readln(fun,c1);
    readln(fun,c2);
    readln(fun,c3);
    readln(fun,c4);
  end;
  c[1]:=c1;
  c[2]:=c2;
  c[3]:=c3;
  c[4]:=c4;
end;

{corpo principale della procedura}
begin
  reset(fun);
  for i:=1 to 6 do
  with grad do
  begin
    readln(fun,st);
    if st='Barx' then
    trova(x,cx)
    else if st='Bary' then
    trova(y,cy)
    else if st='Barz' then
    trova(z,cz)
    else if st='precessione' then
    trova(fi,cf)
    else if st='nutazione' then
    trova(teta,ct)
    else if st='rotazione' then
    trova(cxi,ci);
  end;
  close(fun);
end;

procedure unafunzione(sub,stf:string);
var grad:Tgradi;
    info:textsettingstype;           {Mostra un moto nel riquadro principale}
  begin
      gettextsettings(info);
      assign(fun,stf);
      leggifunc(fun,grad);
      settextjustify(0,0);
      settextstyle(defaultfont,horizdir,1);
      clearviewport;
      setcolor(lightgreen);
      outtextxy(50,50,'Origine Solidale');
      with grad do
      begin
        outtextxy(50,30,'Traslazione');
        outtextxy(20,90,'X(t) : ');outtextxy(70,90,tipo(x,cx));
        outtextxy(20,110,'Y(t) : ');outtextxy(70,110,tipo(y,cy));
        outtextxy(20,130,'Z(t) : ');outtextxy(70,130,tipo(z,cz));
        setcolor(white);
        outtextxy(270,30,'Angoli di Eulero');
        outtextxy(270,50,'Precessione :');outtextxy(270,70,tipo(fi,cf));
        outtextxy(270,90,'Nutazione :');outtextxy(270,110,tipo(teta,ct));
        outtextxy(270,130,'Rotazione propria :');
        outtextxy(270,150,tipo(cxi,ci));
      end;
      setTextjustify(centertext,bottomtext);
      with info do
      settextstyle(font,direction,charsize);
      sotto(triplexfont,sub,white,3);
  end;

procedure unsolido(sub,st:string);
var PA,temp,New:Vpunt;
    color:word;
    grad:Tgradi;
    Bar:Punto3d;                {Mostra un solido nel riquadro principale}
begin                           { (ha bisogno di centro.fct           )  }
  color:=getcolor;
  setcolor(lightgreen);
  assign(store,st);
  assign(fun,'centro.fct');
  leggi(store,PA);
  leggifunc(fun,grad);
  copia(PA,temp);
  copia(temp,New);
  libera(temp);
  baric(PA,Bar);
  cambia(PA,Bar);
  rototrasla(Bar,PA,New,0.03,grad);
  clearviewport;
  cavalf(Bar,2,New);
  sotto(triplexfont,sub,white,3);
  setcolor(color);
  libera(New);
  libera(PA);
end;

procedure base2(var distance,quote:real;var st,stf:string;var ch,Key,cti:char;
               var scala:integer);
var Err:boolean;
    car,sex,inutile:char;            {Acquisisce i dati di input}
    x:integer;
    textinfo:textsettingstype;
    old,porta:viewporttype;
    P:pointer;
    size,color:word;
    aus:string;

begin
  assorbi;
  color:=getcolor;
  gettextsettings(textinfo);
  getviewsettings(old);
  clearviewport;
  percent;
  sopra(320,25,smallfont,4,' Sel. Parametri ',yellow,blue);
  settextstyle(defaultfont,horizdir,1);
  sotto(triplexfont,'',black,3);
  sotto(triplexfont,'Immissione dati',lightcyan,3);
  setcolor(white);
  settextjustify(centertext,0);
  clearviewport;
  sex:='N';
  if st<>'#' then
  repeat
    setcolor(lightgreen);
    outtextxy(220,20,'Solido corrente : '+Maiusc(st)+' .');
    setcolor(white);
    outtextxy(220,40,'Vuole Modificare, Confermare o Visualizzare ? (M/C/V) ');
    sex:=UpCase(readkey);
    if sex='V' then
    begin
      if controlla('Centro.fct') then
      begin
        unsolido(st,st);
        sotto(triplexfont,st,white,4);
      end
      else
      begin
        clearviewport;
        outtextxy(220,80,'Centro.fct non  presente, non posso visualizzare');
        outtextxy(220,100,'il solido '+Maiusc(st))
      end;
      repeat until keypressed;
      assorbi;
      clearviewport;
      sotto(triplexfont,'Immissione dati',lightcyan,3);
    end;
    if sex='M' then riquadro(101,61,539,110)
              else if (sex<>'V') then ch:='E'
  until (sex='M') or (sex='C') or (sex=#13);
  if (sex='M') or (st='#') then
  begin
    outtextxy(220,20,'Desidera immettere un nuovo solido od usarne');
    outtextxy(220,40,'uno gi esistente ? (N/E) ');
    ch:=UpCase(readkey);
    readln;
    if (ch<>'N') then
    begin
      prendis('Immetti solido :','Input File','.dwg',st,white,green);
      stsalvo:=true;
    end
    else stsalvo:=false;
  end;
  if stf<>'#' then
  repeat
    setcolor(lightgreen);
    outtextxy(220,60,'Moto corrente : '+Maiusc(stf)+' .');
    setcolor(white);
    outtextxy(220,80,'Vuole Modificare, Confermare o Visualizzare? (M/C/V)');
    sex:=UpCase(readkey);
    if sex='V' then
    begin
      unafunzione(stf,stf);
      sotto(triplexfont,stf,white,4);
      repeat until keypressed;
      assorbi;
      clearviewport;
      sotto(triplexfont,'Immissione dati',lightcyan,3);
    end;
    if sex='M' then riquadro(101,101,539,131)
              else if (sex<>'V') then cti:='E'
  until (sex='M') or (sex='C') or (sex=#13);
  if (stf='#') or (sex='M') then
  begin
    outtextxy(220,60,'Desidera immettere una nuova funzione od usarne');
    outtextxy(220,80,'una gi esistente ? (N/E) ');
    cti:=UpCase(readkey);
    aus:=cti;
    outtext(aus);
    if (cti<>'N') then
    begin
      prendis('Immetti funzione :','Input File','.fct',stf,blue,white);
      stfsalvo:=true;
    end
    else stfsalvo:=false;
  end;
  outtextxy(220,100,'Prospettiva, Assonometria o Pianta ? (P/A/L) ');
  key:=UpCase(readkey);
  if (key<>'A') and (key<>'P') and (key<>'L') then key:='A';
  aus:=key;
  outtext(aus);
  case key of
  'P':begin
        repeat
          prendir('Distanza dallo schermo <20>:',distance,white,cyan);
          if distance<=0 then
                         begin
                           sound(600);
                           delay(100);
                           nosound;
                           Errore('La distanza deve essere positiva',inutile);
                         end;
        until distance>0;
        prendir('Quota dell''osservatore <40>:',quote,green,white);
      end;
  'A','L':repeat
            prendin('Rapporto di scala <3>:',scala,lightred,white);
            if (scala>7) then
                         begin
                           sound(600);
                           delay(100);
                           nosound;
                           Errore('Scala troppo grande',inutile)
                         end
            else if (scala<=0) then
                               begin
                                 sound(600);
                                 delay(100);
                                 nosound;
                                 Errore('Scala assurda',inutile);
                               end;
          until (scala>0) and (scala<=7);
  end;
end;

procedure opzioni(bch:char;grad:Tgradi;var overch,colch:char;var tempo:real;
                                           var passo:integer);
var der:Tgradi;
    inutile:char;
begin                     {Acquisisce le opzioni finali}
  assorbi;
  deriva(grad,der);
  if not ((bch='S') and not checkpiana(grad,der)) and not checktrasla(grad) then
  begin
    sotto(triplexfont,'Opzioni',lightmagenta,4);
    clearviewport;
    percent;
    if checkpiana(grad,der) then
    begin
      sopra(320,25,smallfont,4,'    Polari      ',yellow,blue);
      outtextxy(220,60,'Il moto  piano, sono definite sia la');
      outtextxy(220,80,'base che la rulletta.                ');
      setcolor(lightcyan);
      outtextxy(220,120,'Polari Sovrapposte o Distinte ? (S/D)');
      setcolor(white);
      overch:=UpCase(ReadKey);
      if overch='S' then
      repeat
        prendir('Coord. temporale origine <3>',tempo,white,cyan);
        if tempo<0 then
        begin
          sound(600);
          delay(100);
          nosound;
          Errore('Non posso risalire prima dell''origine dei tempi',inutile);
        end;
      until tempo>=0;
    end
    else overch:='D';
    if (bch<>'S') and not checkpiana(grad,der) and not zeri(der.z,der.cz) then
    begin
      sopra(320,25,smallfont,4,' Quote e colori ',yellow,blue);
      outtextxy(220,20,'E'' possibile rappresentare la curva intersezione');
      outtextxy(220,40,'della rigata fissa con un piano orizzontale ');
      outtextxy(220,60,'passante per l''origine solidale associando ad ');
      outtextxy(220,80,'intervalli di quota diversi un colore differente.');
      setcolor(lightgreen);
      outtextxy(220,120,'Colori diversi per quote distinte ? (S/N)');
      setcolor(white);
      colch:=UpCase(readkey);
      if colch='S' then
      repeat
        prendin('Passo per la quota <10>:',passo,magenta,white);
        if passo<=0 then
        begin
          sound(600);
          delay(100);
          nosound;
          Errore('Il passo della quota deve essere positivo',inutile);
        end;
      until passo>0;
    end
    else colch:='N';
    if passo=0 then passo:=1;
  end
  else
  begin
    colch:='N';
    overch:='D';
  end;
end;

procedure mostracoord(Bar:Punto3d;PA:Vpunt;key:char;scala:integer);
var ix,iy,iz:integer;
    p3d,Aus:Punto3D;
    p2d,q2d:Punto2D;             {Disegna il solido in prospettiva o   }
    st,sx,sy,sz:string;          {in assonometria e ne mostra le coord.}
    TextInfo:TextsettingsType;   {nello spazio                         }
    color,back:word;
    ch:char;
    port:viewporttype;
    fillinfo:fillsettingstype;
begin
  color:=getcolor;
  back:=getbkcolor;
  getTextsettings(TextInfo);
  setcolor(yellow);
  setbkcolor(blue);
  rectangle(2,2,getmaxx-2,33);
  rectangle(1,1,getmaxx-1,getmaxy-1);
  getfillsettings(fillinfo);
  setviewport(3,3,getmaxx-3,32,clipon);
  setfillstyle(9,magenta);
  floodfill(2,2,getcolor);
  setcolor(getmaxcolor);
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,2);
  outtextxy(round(getmaxx div 2),12,'Coordinate solidali dell''oggetto.');
  settextjustify(0,0);
  setTextStyle(smallfont,horizdir,4);
  getviewsettings(port);
  setviewport(0,34,getmaxx,getmaxy,clipon);
  setcolor(yellow);
  Aus:=Bar;
  Aus.z:=Bar.z+10;
  if key='P' then visualizzaf(Aus,PA)
             else cavalf(Aus,scala,PA);
  setcolor(getmaxcolor);
  while PA<>nil do
  begin
    if key='P' then
    prospf(distance,quote,Aus,PA^.Vcoord,p2d)
    else assonf(Aus,scala,PA^.Vcoord,p2d);
    with PA^.Vcoord,p2d do
    begin
      ix:=round(x);iy:=round(y);iz:=round(z);
      str(ix,sx);str(iy,sy);str(iz,sz);
      st:='(' + sx + ',' + sy + ',' + sz + ')';
      OutTextXY(xs+5,ys-15,st);
    end;
    PA:=PA^.Vsucc;
  end;
  ch:=readkey;
  with TextInfo do
  begin
    setTextStyle(font,direction,charsize);
    settextjustify(horiz,vert);
  end;
  with port do
  setviewport(x1,y1,x2,y2,clip);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  with fillinfo do
  setfillstyle(pattern,color);
  setcolor(color);
  setbkcolor(back);
end;

procedure riferimento (tipo:char;scala:integer);
var lung:integer;
    P1,x1,y1,z1:Punto2d;
    O,Fx,Fy,Fz:Punto3d;
    info:textsettingstype;
    color:word;               {Disegna il sistema di riferimento fisso}
    a:real;
    var titolo:string;

procedure tra(tipo:char;scala:integer;P3d:punto3d;var P2d:punto2d);
begin
  case tipo of
  'A':begin
        asson(scala,P3d,P2d);
        titolo:='Vista Assonometrica';
      end;
  'P':begin
        prosp(distance,quote,P3d,P2d);
        titolo:='Vista Prospettica';
      end;
  'L':begin
        plan(scala,P3d,p2d);
        titolo:='Vista dall''alto';
      end;
  end;
end;

begin
  color:=getcolor;
  gettextsettings(info);
  setcolor(lightcyan);
  settextstyle(defaultfont,horizdir,1);
  settextjustify(0,0);
  lung:=100;
  if tipo='P' then
  begin
    a:=distance+1;
    scala:=1;
  end
  else a:=2;
  O.x:=0;
  O.y:=a;
  O.z:=0;
  Fx:=O;
  Fy:=O;
  Fz:=O;
  Fx.x:=Fx.x+lung;
  Fy.y:=Fy.y+lung;
  Fz.z:=Fz.z+lung;
  tra(tipo,scala,Fx,x1);
  tra(tipo,scala,Fy,y1);
  tra(tipo,scala,Fz,z1);
  tra(tipo,scala,O,P1);
  circle(P1.xs,P1.ys,2*scala);
  line(P1.xs,P1.ys,x1.xs,x1.ys);
  outtextxy(x1.xs+5,x1.ys-10,'x''');
  line(P1.xs,P1.ys,y1.xs,y1.ys);
  outtextxy(y1.xs+5,y1.ys-10,'y''');
  line(P1.xs,P1.ys,z1.xs,z1.ys);
  outtextxy(z1.xs+8,z1.ys-5,'z''');
  outtextxy(15,100,titolo);
  setcolor(color);
  with info do
  begin
    settextstyle(font,direction,charsize);
    settextjustify(horiz,vert);
  end;
end;


procedure centro(Bar:punto3d;Tipo:char;scala:integer;grad,der:Tgradi;t:real);
var p,x,y,z:punto2d;
    lung:integer;                 {Disegna il sist. di riferimento}
    Fx,Fy,Fz,O:punto3d;           {solidale durante l'animazione  }
    info:textsettingstype;
    color:word;
    A:Rcoeff;
    Ang:angoli;
begin
  O.x:=0;
  O.y:=0;
  O.z:=0;
  prep(grad,t,Ang);
  tpr(Ang,A);
  lung:=10;
  gettextsettings(info);
  settextstyle(defaultfont,horizdir,1);
  Fx:=O;
  Fy:=O;
  Fz:=O;
  Fx.x:=lung*scala;
  Fy.y:=lung*scala;
  Fz.z:=lung*scala;
  transf2(A,Fx,Fx);
  transf2(A,Fy,Fy);
  transf2(A,Fz,Fz);
  case Tipo of
  'A':begin
        asson(scala,Bar,P);
        assonf(Bar,scala,Fx,x);
        assonf(Bar,scala,Fy,y);
        assonf(Bar,scala,Fz,z);
      end;
  'P':begin
        prosp(distance,quote,Bar,P);
        prospf(distance,quote,Bar,Fx,x);
        prospf(distance,quote,Bar,Fy,y);
        prospf(distance,quote,Bar,Fz,z);
      end;
  'L':begin
        plan(scala,Bar,P);
        planf(Bar,scala,Fx,x);
        planf(Bar,scala,Fy,y);
        planf(Bar,scala,Fz,z);
      end;
  end;
  color:=getcolor;
  setcolor(lightred);
  circle(P.xs,P.ys,scala);
  line(P.xs,P.ys,x.xs,x.ys);
  line(P.xs,P.ys,y.xs,y.ys);
  line(P.xs,P.ys,z.xs,z.ys);
  setcolor(lightmagenta);
  outtextxy(z.xs+5,z.ys+5,'z');
  outtextxy(x.xs+5,x.ys+5,'x');
  outtextxy(y.xs+5,y.ys+5,'y');
  outtextxy(50,50,'[t='+stri(t)+' s]');
  setcolor(color);
  with info do
  settextstyle(font,direction,charsize);
end;


procedure fai(grad:Tgradi;Bch:char;Bar:Punto3d;scala:integer;PA:Vpunt);
var dt,t:real;
    a,v,time:integer;         {Esegue l'animazione in assonometria}
    ch:char;
    New,temp:Vpunt;
    der:Tgradi;
begin
  copia(Pa,temp);
  copia(temp,New);
  libera(temp);
  deriva(grad,der);
  t:=0;
  time:=0;
  dt:=0.03;
  a:=1;
  v:=0;
  setactivepage(a);
  setvisualpage(v);
  repeat
    t:=t+dt;
    cleardevice;
    rototrasla(Bar,PA,New,t,grad);
    riferimento('A',scala);
    centro(bar,'A',scala,grad,der,t);
    cavalf(Bar,scala,New);
    setcolor(lightgreen);
    asse2(Bar,t,100,Bar.z,grad,der,scala);
    setcolor(getmaxcolor);
    a:=1-a;
    v:=1-v;
    setactivepage(a);
    setvisualpage(v);
    delay(time);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setvisualpage(0);
  setactivepage(0);
  cleardevice;
  libera(New);
end;

procedure fai2(grad:Tgradi;Bar:Punto3d;PA:Vpunt);
var dt,t:real;
    a,v,time:integer;           {Esegue l'animazione in prospettiva}
    ch:char;
    New,temp:Vpunt;
    der:Tgradi;
begin
  copia(Pa,temp);
  copia(temp,New);
  libera(temp);
  deriva(grad,der);
  t:=0;
  time:=0;
  dt:=0.03;
  a:=1;
  v:=0;
  setactivepage(a);
  setvisualpage(v);
  repeat
    t:=t+dt;
    cleardevice;
    rototrasla(Bar,PA,New,t,grad);
    riferimento('P',scala);
    centro(Bar,'P',3,grad,der,t);
    visualizzaf(Bar,New);
    setcolor(lightgreen);
    assep2(Bar,t,90,Bar.z,grad,der);
    setcolor(getmaxcolor);
    a:=1-a;
    v:=1-v;
    setactivepage(a);
    setvisualpage(v);
    delay(time);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setvisualpage(0);
  setactivepage(0);
  cleardevice;
  libera(New);
end;

procedure faip(grad:Tgradi;Bar:Punto3d;scala:integer;PA:Vpunt);
var dt,t:real;
    a,v,time:integer;           {Esegue l'animazione in pianta}
    ch:char;
    New,temp:Vpunt;
    der:Tgradi;
begin
  copia(Pa,temp);
  copia(temp,New);
  libera(temp);
  deriva(grad,der);
  t:=0;
  time:=0;
  dt:=0.03;
  a:=1;
  v:=0;
  setactivepage(a);
  setvisualpage(v);
  repeat
    t:=t+dt;
    cleardevice;
    rototrasla(Bar,PA,New,t,grad);
    riferimento('L',scala);
    centro(Bar,'L',scala,grad,der,t);
    piantaf(Bar,New,scala);
    setcolor(lightgreen);
    assel2(Bar,t,100,Bar.z,grad,der,scala);
    setcolor(getmaxcolor);
    a:=1-a;
    v:=1-v;
    setactivepage(a);
    setvisualpage(v);
    delay(time);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setvisualpage(0);
  setactivepage(0);
  cleardevice;
  libera(New);
end;

procedure assecaval(grad:Tgradi;scala:integer;PA:Vpunt;Bch:char;Bar:Punto3d);
var t,dt:real;
    color:word;             {Disegna la rigata fissa in assonometria}
    der:Tgradi;
    temp,New:Vpunt;
    ch:char;
begin
  cleardevice;
  outtextxy(320,6,'Rigata fissa :');
  setviewport(0,10,getmaxx,getmaxy,clipon);
  t:=0;
  dt:=0.02;
  copia(PA,temp);
  copia(temp,New);
  libera(TEMP);
  deriva(grad,der);
  repeat
    t:=t+dt;
    color:=round(t) mod 16+1;
    setcolor(color);
    asse(Bar,t,100,Bar.z,grad,der,scala);
    rototrasla(Bar,PA,New,t,grad);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  libera(New);
  setcolor(getmaxcolor);
  setviewport(0,0,getmaxx,getmaxy,clipon)
end;

procedure assecavalsol(grad:Tgradi;scala:integer);
var t,dt:real;
    color:word;
    der:Tgradi;                 {Disegna la rigata solidale in assonometria}
    ch:char;
    O:Punto3d;
begin
  cleardevice;
  with O do
  begin
    x:=0;
    y:=0;
    z:=0
  end;
  outtextxy(320,6,'Rigata solidale :');
  setviewport(0,10,getmaxx,getmaxy,clipon);
  t:=0;
  dt:=0.02;
  deriva(grad,der);
  repeat
    t:=t+dt;
    color:=round(t) mod 16+1;
    setcolor(color);
    asses(O,t,120,0,grad,der,scala);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setcolor(getmaxcolor);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;

procedure asseplan(grad:Tgradi;scala:integer;PA:Vpunt;Bar:Punto3d);
var t,dt:real;
    color:word;
    der:Tgradi;                 {Disegna la rigata fissa in pianta}
    temp,New:Vpunt;
    ch:char;
begin
  cleardevice;
  outtextxy(320,6,'Rigata fissa :');
  setviewport(0,10,getmaxx,getmaxy,clipon);
  t:=0;
  dt:=0.02;
  copia(PA,temp);
  copia(temp,New);
  libera(temp);
  deriva(grad,der);
  repeat
    t:=t+dt;
    color:=round(t) mod 16+1;
    setcolor(color);
    assel(Bar,t,100,Bar.z,grad,der,scala);
    rototrasla(Bar,PA,New,t,grad);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  libera(New);
  setcolor(getmaxcolor);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;

procedure asseplansol(grad:Tgradi;scala:integer);
var t,dt:real;
    color:word;
    der:Tgradi;                 {Disegna la rigata solidale in pianta}
    ch:char;
    O:Punto3d;
begin
  cleardevice;
  outtextxy(320,6,'Rigata solidale :');
  setviewport(0,10,getmaxx,getmaxy,clipon);
  with O do
  begin
    x:=0;
    y:=0;
    z:=0
  end;
  t:=0;
  dt:=0.02;
  deriva(grad,der);
  repeat
    t:=t+dt;
    color:=round(t) mod 16+1;
    setcolor(color);
    assels(O,t,120,0,grad,der,scala);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setcolor(getmaxcolor);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;

procedure asseprosp(grad:Tgradi;PA:Vpunt;Bar:Punto3d);
var t,dt:real;
    color:word;
    der:Tgradi;                 {Disegna la rigata fissa in prospettiva}
    temp,New:Vpunt;
    ch:char;
begin
  cleardevice;
  t:=0;
  dt:=0.02;
  outtextxy(320,6,'Rigata fissa :');
  setviewport(0,10,getmaxx,getmaxy,clipon);
  copia(PA,temp);
  copia(temp,New);
  libera(temp);
  deriva(grad,der);
  repeat
    t:=t+dt;
    color:=round(t) mod 16+1;
    setcolor(color);
    assep(Bar,t,100,Bar.z,grad,der);
    rototrasla(Bar,PA,New,t,grad);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  libera(New);
  setcolor(getmaxcolor);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;

procedure asseprospsol(grad:Tgradi);
var t,dt:real;
    color:word;
    der:Tgradi;               {Disegna la rigata solidale in prospettiva}
    ch:char;
    O:Punto3d;
begin
  cleardevice;
  outtextxy(320,6,'Rigata solidale :');
  setviewport(0,10,getmaxx,getmaxy,clipon);
  with O do
  begin
    x:=0;
    y:=0;
    z:=0
  end;
  t:=0;
  dt:=0.02;
  deriva(grad,der);
  repeat
    t:=t+dt;
    color:=round(t) mod 16+1;
    setcolor(color);
    asseps(O,t,100,0,grad,der);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setcolor(getmaxcolor);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;

procedure assis;
var xc,yc:integer;
    color:word;
    info:textsettingstype;
begin                          {Traccia gli assi cartesiani solidali}
                               {nella rappresentazione della polare }
  gettextsettings(info);
  settextstyle(defaultfont,Horizdir,1);
  color:=getcolor;
  setcolor(lightmagenta);
  xc:=getmaxx div 2;
  yc:=getmaxy div 2;
  line(xc,0,xc,getmaxy);
  outtextxy(xc+20,20,'Y');
  line(0,yc,getmaxx,yc);
  outtextxy(getmaxx-20,yc+20,'X');
  setcolor(color);
  with info do
  settextstyle(font,direction,charsize);
end;

procedure assis2(scala:integer;Bar:Punto3d);
var xc,yc,lungx,lungy:integer;
    color:word;
    b:punto2d;
    ori:punto3d;
    info:textsettingstype;
begin                          {Traccia gli assi cartesiani solidali}
                               {nella rappresentazione della polare }
                               {sovrapposta                         }
  gettextsettings(info);
  settextstyle(defaultfont,Horizdir,1);
  color:=getcolor;
  setcolor(lightred);
  lungx:=40*scala;
  lungy:=round(lungx*corr);
  ori.x:=0;
  ori.y:=0;
  ori.z:=0;
  planf(bar,scala,ori,b);
  xc:=b.xs;
  yc:=b.ys-50;
  line(xc,yc-lungy,xc,yc+lungy);
  outtextxy(xc+10,yc-lungy,'Y');
  line(xc-lungx,yc,xc+lungx,yc);
  outtextxy(xc+lungx,yc+10,'X');
  setcolor(color);
  with info do
  settextstyle(font,direction,charsize);
end;

procedure assi;
var xc,yc:integer;                 {Traccia gli assi cartesiani fissi   }
    color:word;                    {nella rappresentazione della polare }
    info:textsettingstype;

begin
  gettextsettings(info);
  settextstyle(defaultfont,Horizdir,1);
  color:=getcolor;
  setcolor(lightmagenta);
  xc:=getmaxx div 2;
  yc:=getmaxy -50;
  line(xc,0,xc,getmaxy);
  outtextxy(xc+20,20,'Y''');
  line(0,yc,getmaxx,yc);
  outtextxy(getmaxx-20,yc+20,'X''');
  setcolor(color);
  with info do
  settextstyle(font,direction,charsize);
end;

{}
procedure scriviq(i:integer;oldr,r:real;sit:boolean);
var x,j:integer;
    col:word;                        {Scrive le quote sul video}
begin
  if sit then
  begin
    if i<=30 then
           begin
             x:=540;
             j:=i;
           end
           else
           begin
             x:=590;
             j:=i-31;
           end;
    outtextxy(x,10+j*10,'[z='+stri(r)+']');
  end
  else
  begin
    x:=510;
    j:=0;
    col:=getcolor;
    setcolor(white);
    numero(x,j,oldr,r,(abs(oldr)>abs(r)) or ((oldr<0) and (r>=0)));
    setcolor(getcolor);
  end;
end;

procedure traccia(PA:Vpunt;grad:Tgradi;scala:integer;Bar:Punto3d;Bch,
                  overch,colch:char;passo:integer);
var temp,new:vpunt;
    ch:char;
    t,dt:real;                          {Disegna la polare fissa}
    Q3d,P3d,Aus,oldbar:punto3d;
    q2d,p2d,O:punto2d;
    der:tgradi;
    color,bk,oldcol,auscol:word;
    textinfo:textsettingstype;
    i:integer;
    colq,siq,sit:boolean;
    st:string;

begin
  deriva(grad,der);
  colq:=(bch<>'S') and (overch<>'S') and (colch='S') and not zeri(der.z,der.cz);
  gettextsettings(textinfo);
  O.xs:=getmaxx div 2;
  O.ys:=50;
  cleardevice;
  if checkpiana(grad,der) then
  begin
    outtextxy(320,6,'Polare fissa :');
  end
  else if bch<>'S' then
  begin
    outtextxy(320,6,'Intersezione di un piano orizz. per l''origine solidale della rigata fissa:');
  end
  else
  begin
    outtextxy(320,6,'Intersezione della rigata fissa con il piano z='+stri(qpiano));
  end;
  color:=getcolor;
  bk:=getbkcolor;
  setviewport(0,10,getmaxx,getmaxy,clipon);
  t:=0;
  dt:=0.01;
  copia(PA,New);
  setcolor(lightgreen);
  rototrasla(Bar,PA,New,t,grad);
  omega1(t,check(bch,Bar),grad,der,p3d);
  siq:=colq and true;
  sit:=false;
  assi;
  oldcol:=getcolor;
  oldbar:=bar;
  if colq and siq then
  begin
    settextstyle(smallfont,horizdir,4);
    if not sit then settextjustify(0,0);
    scriviq(i,oldbar.z,Bar.z,sit);
  end;
  i:=0;
  i:=i+1;
  repeat
    Aus:=p3d;
    t:=t+dt;
    omega1(t,check(bch,Bar),grad,der,p3d);
    plan(scala,p3d,p2d);
    plan(scala,aus,q2d);
    sis(O,p2d,p2d);
    sis(O,q2d,q2d);
    Putpixel(p2d.xs,p2d.ys,yellow);
    if colq then sceglicol(round(Bar.z/passo) mod 16);
    auscol:=getcolor;
    if (auscol<>oldcol) and siq then
    begin
      scriviq(i,oldbar.z,Bar.z,sit);
      i:=i+1;
    end;
    oldcol:=auscol;
    oldbar:=bar;
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    rototrasla(Bar,PA,New,t,grad);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  with textinfo do
  begin
    settextstyle(font,direction,charsize);
    settextjustify(horiz,vert);
  end;
  libera(New);
  setcolor(color);
  setbkcolor(bk);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;

procedure traccias(grad:Tgradi;scala:integer);
var ch:char;
    t,dt:real;
    Q3d,P3d,Aus:punto3d;
    q2d,p2d:punto2d;                   {Disegna la polare solidale}
    der:tgradi;
    color,bk:word;
    O:Punto2d;

begin
  O.xs:=getmaxx div 2;
  O.ys:=getmaxY div 2;
  cleardevice;
  deriva(grad,der);
  if checkpiana(grad,der) then
  begin
    outtextxy(320,6,'Polare mobile :');
  end
  else
  begin
    outtextxy(320,6,'Intersezione della rigata solidale con il piano z='+stri(qpiano));
  end;
  color:=getcolor;
  bk:=getbkcolor;
  setviewport(0,10,getmaxx,getmaxy,clipon);
  t:=0;
  dt:=0.01;
  setcolor(lightcyan);
  omega2(t,qpiano,grad,der,p3d);
  assis;
  repeat
    Aus:=p3d;
    t:=t+dt;
    omega2(t,qpiano,grad,der,p3d);
    plan(scala,p3d,p2d);
    plan(scala,aus,q2d);
    sis(O,p2d,p2d);
    sis(O,q2d,q2d);
    Putpixel(p2d.xs,p2d.ys,yellow);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setcolor(color);
  setbkcolor(bk);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;

procedure traccias2(tempo:real;Bar:punto3d;grad:Tgradi;scala:integer);
var ch:char;
    t,dt:real;
    Q3d,P3d,Aus:punto3d;
    q2d,p2d:punto2d;                   {Disegna la polare solidale}
    der:tgradi;                        {sovrapposta               }
    color,bk:word;
    O:Punto2d;
    Ori:punto3d;

begin
  deriva(grad,der);
  ori.x:=0;
  ori.y:=0;
  ori.z:=0;
  trasla(Bar,grad,tempo);
  planf(Bar,scala,ori,O);
  O.ys:=O.ys-50;
  if checkpiana(grad,der) then
  begin
    color:=getcolor;
    setcolor(lightgreen);
    riquadro(0,0,getmaxx,9);
    outtextxy(320,6,'Polare mobile sovrapposta:');
    setcolor(color);
  end
  else
  begin
    outtextxy(320,6,'Intersezione della rigata solidale con il piano z='+stri(qpiano));
  end;
  color:=getcolor;
  bk:=getbkcolor;
  setviewport(0,10,getmaxx,getmaxy,clipon);
  t:=0;
  dt:=0.01;
  setcolor(lightcyan);
  omega2(t,qpiano,grad,der,p3d);
  assis2(scala,bar);
  repeat
    Aus:=p3d;
    t:=t+dt;
    omega2(t,qpiano,grad,der,p3d);
    planf(bar,scala,p3d,p2d);
    planf(bar,scala,aus,q2d);
    p2d.ys:=p2d.ys-50;
    q2d.ys:=q2d.ys-50;
    Putpixel(p2d.xs,p2d.ys,yellow);
    line(p2d.xs,p2d.ys,q2d.xs,q2d.ys);
    if keypressed then ch:=UpCase(ReadKey);
  until ch=#27;
  setcolor(color);
  setbkcolor(bk);
  setviewport(0,0,getmaxx,getmaxy,clipon);
end;


procedure salvafunc (var fun:text;grad:Tgradi);
var i:integer;

function par (Tipo:char):integer;     {Salva una nuova funzione}
begin                                 {in un file di testo     }
  case Tipo of
  'L':par:=2;
  'Q':par:=3;
  'N','S','C','E','F':par:=4;
  end;
end;

function tipo (ch:char):string;
begin
  case ch of
  'L':tipo:='At+B';
  'Q':tipo:='At^2+Bt+C';
  'S':tipo:='Asen(wt+f)+B';
  'C':tipo:='Acos(wt+f)+B';
  'E':tipo:='Aesp(wt+f)+B';
  'N':tipo:='Aln(wt+f)+B';
  'F':tipo:='A/(wt+f)+B';
  end;
end;

begin
  rewrite(fun);
  with grad do
  begin
    writeln(fun,'Barx');
    writeln(fun,tipo(x));
    for i:=1 to par(x) do
    writeln(fun,cx[i]);
    writeln(fun,'Bary');
    writeln(fun,tipo(y));
    for i:=1 to par(y) do
    writeln(fun,cy[i]);
    writeln(fun,'Barz');
    writeln(fun,tipo(z));
    for i:=1 to par(z) do
    writeln(fun,cz[i]);
    writeln(fun,'precessione');
    writeln(fun,tipo(fi));
    for i:=1 to par(fi) do
    writeln(fun,cf[i]);
    writeln(fun,'nutazione');
    writeln(fun,tipo(teta));
    for i:=1 to par(teta) do
    writeln(fun,ct[i]);
    writeln(fun,'rotazione');
    writeln(fun,tipo(cxi));
    for i:=1 to par(cxi)-1 do
    writeln(fun,ci[i]);
    write(fun,ci[par(cxi)]);
  end;
  close(fun)
end;

procedure salvasolido (PA:Vpunt;var fil:text);
var i,j,lung,leg:integer;
    Vp:Vpunt;
    Lp:Lpunt;                           {Salva un nuovo solido}
                                        {in un file di testo  }

function profonda(Lp:Lpunt):integer;
var p:integer;
begin
  p:=0;
  while Lp<>nil do
  begin
    p:=p+1;
    Lp:=Lp^.Lsucc;
  end;
  profonda:=p;
end;

function conta (PA:Vpunt):integer;
var c:integer;
begin
  c:=0;
  while PA<>nil do
  begin
    if PA^.Link<>nil then c:=c+1;
    PA:=PA^.Vsucc;
  end;
  conta:=c;
end;

procedure scrivi(Link:Lpunt);
var Vp:Vpunt;
begin
  while Link<>nil do
  begin
    Vp:=Link^.Rif;
    with Vp^.Vcoord do
    writeln(fil,x,' ',y,' ',z);
    Link:=Link^.Lsucc;
  end;
end;

{corpo principale della procedura}
begin
  lung:=lunga(PA);
  leg:=conta(PA);
  Vp:=PA;
  rewrite(fil);
  writeln(fil,lung);
  while Vp<>nil do
  with Vp^.Vcoord do
  begin
    writeln(fil,x,' ',y,' ',z);
    Vp:=Vp^.Vsucc;
  end;
  writeln(fil,leg);
  Vp:=PA;
  while Vp<>nil do
  with Vp^ do
  begin
    if Link<>nil then
    begin
      writeln(fil,'vertice');
      with Vcoord do writeln(fil,x,' ',y,' ',z);
      writeln(fil,'legami_');
      writeln(fil,profonda(Link));
      scrivi(Link);
    end;
    Vp:=Vp^.Vsucc;
  end;
  close(fil);
end;

procedure solidi;
var ch:char;
    PA,temp,New:Vpunt;          {Mostra tutti i solidi presenti}
    grad:Tgradi;
    Bar:Punto3d;
    color:word;
    nome:string;
    i,ldir:integer;
    trovato:boolean;
    Indir:listadir;

begin
  clearviewport;
  trovato:=false;
  percent;
  sopra(320,25,smallfont,4,' Visione Solidi ',yellow,blue);
  color:=getcolor;
  setcolor(lightgreen);
  settextstyle(triplexfont,horizdir,4);
  if controlla('centro.fct') then
  begin
    outtextxy(220,70,'Sequenza Solidi');
    outtextxy(220,130,'<Q> per Interrompere');
    sotto(triplexfont,'Premere Invio per continuare',yellow,3);
    ch:=#13;
    crealistadir(Indir,trovato,'*.dwg');
    I:=1;
    ldir:=lungadir(Indir);
    if trovato then
    repeat
      case ch of
      #77:if i<ldir then i:=i+1
                    else i:=1;
      #75:if i>1 then i:=i-1
                 else i:=ldir;
      end;
      trovadir(Indir,i,nome);
      if controlla(nome) and avanti_indietro(ch) then
      unsolido(nome,nome);
      ch:=UpCase(readdoppio);
    until (ch='Q') or (ch=#27)
    else
    begin
      clearviewport;
      settextstyle(triplexfont,horizdir,4);
      outtextxy(220,70,'Non  stato trovato');
      outtextxy(220,130,'alcun solido (*.dwg)');
      sotto(triplexfont,'Premere un tasto per continuare',green,3);
      repeat until keypressed;
      assorbi;
    end;
  end
  else
  begin
    trovato:=true;
    outtextxy(220,70,'Impossibile operare:');
    outtextxy(220,130,'manca CENTRO.FCT');
    sotto(triplexfont,'Premere un tasto per continuare',green,3);
    repeat until keypressed;
    assorbi;
  end;
  setcolor(color);
  rilasciadir(Indir);
end;

procedure funzioni;
var ch:char;
    grad:Tgradi;                {Mostra tutti i moti presenti}
    Dirinfo:SearchRec;
    color:word;
    trovato:boolean;
    i,ldir:integer;
    nome:string;
    Indir:listadir;

begin
  clearviewport;
  percent;
  trovato:=false;
  sopra(320,25,smallfont,4,'Visione Funzioni',yellow,blue);
  color:=getcolor;
  setcolor(lightgreen);
  settextstyle(triplexfont,horizdir,4);
  outtextxy(220,70,'Sequenza Funzioni');
  outtextxy(220,130,'<Q> per Interrompere');
  sotto(triplexfont,'Premere Invio per continuare',yellow,3);
  settextstyle(defaultfont,Horizdir,1);
  ch:=readkey;
  ch:=#13;
  crealistadir(Indir,trovato,'*.fct');
  I:=1;
  ldir:=lungadir(Indir);
  if trovato then
  repeat
    case ch of
    #77:if i<ldir then i:=i+1
                  else i:=1;
    #75:if i>1 then i:=i-1
               else i:=ldir;
    end;
    trovadir(Indir,i,nome);
    if controlla(nome) and avanti_indietro(ch) then
    unafunzione(nome,nome);
    ch:=UpCase(readdoppio);
  until (ch='Q') or (ch=#27)
  else
  begin
    clearviewport;
    settextstyle(triplexfont,horizdir,4);
    outtextxy(220,70,'Non  stato trovato');
    outtextxy(220,130,'alcun file di moto (*.fct)');
    sotto(triplexfont,'Premere un tasto per continuare',green,3);
    repeat until keypressed;
    assorbi;
  end;
  setcolor(color);
  setTextjustify(centertext,bottomtext);
  rilasciadir(Indir);
end;

procedure salva2 (Avv:boolean;PA:Vpunt;ch,cti:char;var fil,fil2:text);
var key,car,Dwch:char;
    Err:boolean;                   {Salva eventuali nuovi solidi o moti}
    textinfo:textsettingstype;
    port:viewporttype;
    p:pointer;
    xput,yput:integer;
    color,taglia:word;
    oldst,oldstf:string;

begin
  if ((cti='N') or (ch='N')) and (not stsalvo or not stfsalvo) then
  begin
    oldst:=stsic;
    oldstf:=stfsic;
    color:=getcolor;
    gettextsettings(textinfo);
    clearviewport;
    if Avv then
    begin
      setcolor(white);
      getviewsettings(port);
      setviewport(0,0,getmaxx,getmaxy,clipon);
      sopramem(320,25,'Attenzione :se non vengono salvati ora, i dati in mem. si perderanno',taglia,P,xput,yput);
      with port do
      setviewport(x1,y1,x2,y2,clip);
    end;
    settextjustify(centertext,bottomtext);
    settextstyle(defaultfont,horizdir,1);
    sotto(triplexfont,'Registrazione nuovi dati',yellow,3);
    if (cti='N') and not stfsalvo then
    begin
      outtextxy(220,60,'Vuoi salvare la funzione in memoria? (S/N)');
      car:=UpCase(readkey);
      if (car='S') or (car=#13) then
      begin
        prendis2('Immetti nome funzione :','Input File','.fct',stfsic,white,magenta);
        assign(fil,stfsic);
        {}
        if DiskWriteClose(fil) then
        repeat
          sound(600);
          delay(100);
          nosound;
          Errore('Errore di scrittura; <Esc> Annulla, <Enter> Riprova',Dwch);
        until (Dwch=#27) or not DiskWriteClose(fil);
        if (Dwch=#27) then
        begin
          stfsic:=oldstf;
          if Avv then
          begin
            setcolor(lightgreen);
            outtextxy(220,18,'Moto cancellato dalla memoria');
            setcolor(white);
          end;
        end;
        {}
        if Dwch<>#27 then
        begin
          salvafunc(fil,grad);
          stfsalvo:=true;
          setcolor(lightgreen);
          outtextxy(220,18,'Moto '+Maiusc(stfsic)+' salvato con successo.');
          setcolor(white);
        end;
      end
      else if Avv then
      begin
        setcolor(lightgreen);
        outtextxy(220,18,'Moto cancellato dalla memoria');
        setcolor(white);
      end;

    end;
    if (ch='N') and not stsalvo then
    begin
      outtextxy(220,80,'Vuoi salvare il solido in memoria? (S/N)');
      key:=UpCase(readkey);
      if (key='S') or (key=#13) then
      begin
        prendis2('Immetti nome solido :','Input File','.dwg',stsic,magenta,white);
        assign(fil2,stsic);
        {}
        if DiskWriteClose(fil2) then
        repeat
          sound(600);
          delay(100);
          nosound;
          Errore('Errore di scrittura; <Esc> Annulla, <Enter> Riprova',Dwch);
        until (Dwch=#27) or not DiskWriteClose(fil2);
        if Dwch=#27 then
        begin
          stsic:=oldst;
          if Avv then
          begin
            setcolor(lightcyan);
            outtextxy(220,38,'Solido cancellato dalla memoria');
            setcolor(white);
          end;
        end;
        {}
        if Dwch<>#27 then
        begin
          if not assoluto then
          begin
            torna(PA,Bar);
            assoluto:=true;
          end;
          salvasolido(PA,fil2);
          stsalvo:=true;
          setcolor(lightcyan);
          outtextxy(220,38,'Solido '+Maiusc(stsic)+' salvato con successo');
          setcolor(white);
        end;
      end
      else if Avv then
      begin
        setcolor(lightcyan);
        outtextxy(220,38,'Solido cancellato dalla memoria');
        setcolor(white);
      end;
    end;
  if Avv then
  begin
    setviewport(0,0,getmaxx,getmaxy,clipon);
    putimage(xput,yput,P^,normalput);
    freemem(P,taglia);
    with port do setviewport(x1,y1,x2,y2,clip);
    setcolor(color);
  end;
  end;
end;

procedure menu (var ch:char);

var info:textsettingstype;
    color:word;                 {Mostra men casi particolari}
    key:char;
    Verr:boolean;
    port:viewporttype;
    Errori:mist;

procedure testa(var Errori:mist);
var Err:Boolean;                   {Controlla quali files relativi agli}
    i:integer;                     {esempi sono presenti nel disco     }

begin
  for i:=1 to Enum do Errori[i]:=i;
  if not controlla('prisma.dwg') or not controlla('striscia.fct') then Errori[1]:=0;
  if not controlla('asta.dwg') or not controlla('barra.fct') then Errori[2]:=0;
  if not controlla('trott.dwg') or not controlla('coni.fct') then Errori[3]:=0;
  if not controlla('suppira.dwg') or not controlla('spirale.fct') then Errori[4]:=0;
  if not controlla('pend.dwg') or not controlla('focault.fct') then Errori[5]:=0;
  if not controlla('ogiva.dwg') or not controlla('proiett.fct') then Errori[6]:=0;
  if not controlla('cubo.dwg') or not controlla('osc1.fct') then Errori[7]:=0;
  if not controlla('elle.dwg') or not controlla('roto2.fct') then Errori[8]:=0;
  if not controlla('cubo.dwg') or not controlla('fiore.fct') then Errori[9]:=0;
  if not controlla('trott2.dwg') or not controlla('trott.fct') then Errori[10]:=0;
end;

function guarda(ch:char;Errori:mist):boolean;
var st:string;
    i,code:integer;          {D true se i files corrispondenti all'esempio}
begin                        {sono nella directory corrente                }
  st:=ch;
  val(st,i,code);
  if (code<>0) or (i>Enum) or (Errori[i]=0) then guarda:=False
                                            else guarda:=true;
end;

begin
  color:=getcolor;
  gettextsettings(info);
  clearviewport;
  percent;
  sopra(320,25,smallfont,4,'Casi Particolari',yellow,blue);
  settextjustify(centertext,bottomtext);
  settextstyle(defaultfont,horizdir,1);
    testa(Errori);
    clearviewport;
    setcolor(lightred);
    outtextxy(220,15,'Men percorsi');
    settextjustify(0,0);
    setcolor(white);
    outtextxy(40,30,'1) ');
    outtextxy(40,45,'2) ');
    outtextxy(40,60,'3) ');
    outtextxy(40,75,'4) ');
    outtextxy(40,90,'5) ');
    outtextxy(40,105,'6) ');
    outtextxy(40,120,'7) ');
    outtextxy(40,135,'8) ');
    outtextxy(40,150,'9) ');
    outtextxy(40,165,'0) ');
    setcolor(lightgreen);
    if Errori[1]=0 then setcolor(7);
    outtextxy(70,30,'Moto di rotolamento');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[2]=0 then setcolor(7);
    outtextxy(70,45,'Asta rigida con vertici su assi ortogonali');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[3]=0 then setcolor(7);
    outtextxy(70,60,'Coni di Poinsot');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[4]=0 then setcolor(7);
    outtextxy(70,75,'Spirale ascendente');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[5]=0 then setcolor(7);
    outtextxy(70,90,'Pendolo di Focault');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[6]=0 then setcolor(7);
    outtextxy(70,105,'Moto di un proiettile');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[7]=0 then setcolor(7);
    outtextxy(70,120,'Rotazione attorno ad un punto variabile');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[8]=0 then setcolor(7);
    outtextxy(70,135,'Precessione quadratica con centro su una crf.');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[9]=0 then setcolor(7);
    outtextxy(70,150,'Ascensore rotante frenato');
    if getcolor<>lightgreen then setcolor(lightgreen);
    if Errori[10]=0 then setcolor(7);
    outtextxy(70,165,'Trottola con vertice sospeso');
    sotto(triplexfont,'Scegliere caso particolare',yellow,3);
    selez(ch,5,21,428,1,10,15,red,Errori);
  setcolor(color);
  if (ch<>#27) and ((ch<'0') or (ch>'9') or not guarda(ch,Errori)) then ch:='N';
  with info do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
end;

procedure scelta(var sch:char;var distance,quote:real;var st,stf:string;var ch,Key,cti:char;
               var scala:integer;var PA:Vpunt; var grad:Tgradi);
var ch1:char;
    color:word;                {Chiede se si vogliono visionari i solidi}
    info:textsettingstype;     {o i moti o i casi particolari presenti  }
begin
  repeat
    clearviewport;
    sopra(320,25,smallfont,4,'Men  Principale',yellow,blue);
    percent;
    settextstyle(triplexfont,Horizdir,3);
    color:=getcolor;
    gettextsettings(info);
    setcolor(green);
    settextjustify(lefttext,bottomtext);
    clearviewport;
    outtextxy(20,35,'- Visione dei solidi');
    outtextxy(20,65,'- Lettura delle funzioni');
    outtextxy(20,95,'- Percorso guidato');
    outtextxy(20,125,'- Selezione parametri fondamentali');
    outtextxy(20,155,'- Animazione principale');
    sotto(triplexfont,'<F1> Help     <ALT-X> Quit',lightgreen,3);
    settextjustify(centertext,bottomtext);
    selez2(ch1,3,17,432,1,5,15,lightblue);
    case ch1 of
    '1':solidi;
    '2':funzioni;
    '3':menu(sch);
    '4':begin
          {}
          salva2(True,PA,ch,cti,fil,fil2);
          {}
          st:=stsic;
          stf:=stfsic;
          base2(distance,quote,st,stf,ch,key,cti,scala);
          stsic:=st;
          stfsic:=stf;
          param:=true;
          if ch='N' then
              begin
                if (ciclo > 1) then libera(PA);
                code:=0;
                PA:=nil;
                restorecrtmode;
                immetti(PA,n);
                if cti<>'N' then
                begin
                  setgraphmode(getgraphmode);
                  sfondo;
                  sotto(triplexfont,'Immissione Dati',lightcyan,3);
                end;
              end;
          if cti='N' then
               begin
                 if ch<>'N' then
                 restorecrtmode;
                 input(grad);
                 setgraphmode(getgraphmode);
                 sfondo;
                 sotto(triplexfont,'Immissione Dati',lightcyan,3);
               end
        end;
    '5',#27:if not param then
            begin
              sound(800);
              delay(100);
              nosound;
              sotto(Triplexfont,'Premere un tasto per continuare',lightmagenta,3);
              Errore('Non sono stati introdotti i parametri fondamentali',ch1);
            end;
    #45:begin
          closegraph;
          clrscr;
          writeln('      Goodbye....');
          halt(0);
        end;
    #59:sceltahelp(EsN);
    end;
    until ((ch1='3') and (sch<>#27)) or ((ch1='5') or (ch1=#27)) and param;
    if (ch1='5') or (ch1=#27) then sch:='N';
    if (ch1='5') or (ch1=#27) then sotto(triplexfont,'Premere invio per continuare',white,3);
    setcolor(color);
    with info do
    begin
      settextstyle(font,direction,charsize);
      settextjustify(horiz,vert);
    end;
end;

procedure resto(var Bar:punto3d;var Bch:char;Var qpiano:real);
var ch:char;
    st:string;              {Acquisisce origine solidale e quota}
begin                       {del piano che individua le polari  }
  clearviewport;
  percent;
  settextstyle(defaultfont,horizdir,1);
  setcolor(white);
  sopra(320,25,smallfont,4,' Sist.  di  rif. ',yellow,blue);
  sotto(triplexfont,'Modifica delle condizioni di default',yellow,3);
  settextjustify(centertext,bottomtext);
  outtextxy(220,40,'Che origine solidale si desidera scegliere ?');
  with Bar do
  st:='Il baricentro  ('+stri(x)+','+stri(y)+','+stri(z)+')';
  outtextxy(220,60,st);
  outtextxy(220,80,'L''attuale origine  il baricentro,');
  outtextxy(220,100,'si desidera cambiare ? (S/N)');
  ch:=UpCase(readkey);
  if (ch='S') then
  prendip('Nuova origine :',Bar,magenta,white);
  qpiano:=Bar.z;
  sopra(320,25,smallfont,4,'Quota del piano ',yellow,blue);
  outtextxy(220,120,'Si desidera cambiare la quota di intercettazione del-');
  outtextxy(220,140,'l''asse nel sist. di rif. fisso <'+stri(qpiano)+'> (S/N)');
  Bch:=UpCase(readkey);
  if Bch='S' then
  prendir('Nuova quota fissa :',qpiano,white,cyan);
end;

{programma principale}
begin
  ciclo:=0;
  mem:=memavail;
  if mem<=memnecc then
  begin
    writeln('Memoria insufficiente (necessari circa 207 kb liberi).');
    writeln('Memoria trovata libera: ',(memavail+138896) div 1024,' Kbytes.');
  end
  else
  begin                                       {in cfont.uty si trova il }
    fontst:='';                               {path di ricerca dei fonts}
    if controlla('cfont.uty') then            {per la grafica           }
    begin
      Assign(fontpath,'cfont.uty');
      reset(fontpath);
      readln(fontpath,fontaus);
      if fontaus='File di controllo del path dei fonts' then
      begin
        readln(fontpath,fontst);
        if not controlla(fontst+'\egavga.bgi') then fontst:='';
      end;
      close(fontpath);
    end;
    if fontst<>'' then fontaus:=fontst+'\'
                  else fontaus:=fontst;
    if not controlla(fontaus+'egavga.bgi') or not controlla(fontaus+'litt.chr')
    or not controlla(fontaus+'sans.chr') or not controlla(fontaus+'goth.chr') or
    not controlla(fontaus+'trip.chr') then
    begin
      clrscr;
      writeln('''Asse Istantaneo di Moto'' : i files di gestione della grafica');
      writeln('non sono stati trovati n nella directory indicata in CFONT.UTY,');
      writeln('n in quella corrente.');
      gotoxy(1,10);
      writeln('Immettere path completo per ''egavga.bgi'' e per i fonts (devono');
      write('essere contenuti nella stessa directory) :');
      read(fontst);
    end;
    pres(Verr,fontst);
    stsic:='#';
    stfsic:='#';
    ch:='#';
    cti:='#';
    Param:=false;
    if not Verr then
    repeat
      if (ciclo < maxlongint) then ciclo:=ciclo+1;
      scelta(sch,distance,quote,st,stf,ch,key,cti,scala,PA,Grad);
      if Sch='N' then
      begin
        if ch<>'N' then
              begin
                if (ciclo > 1) then libera(PA);
                PA:=nil;
                code:=0;
                assign(store,st);
                leggi(store,PA);
              end;
        if cti<>'N' then
               begin
                 assign(fun,stf);
                 leggifunc(fun,grad);
               end;
        baric(PA,Bar);
        resto(Bar,bch,qpiano);
        opzioni(bch,grad,overch,colch,tempo,passo);
        traslazione:=checktrasla(grad);
        cambia(PA,Bar);
        setviewport(0,0,getmaxx,getmaxy,clipon);
        if not Verr then
        begin
          settextstyle(smallfont,Horizdir,4);
          settextjustify(centertext,bottomtext);
          cleardevice;
          case key of
            'A':
            begin
              mostracoord(Bar,PA,key,scala);
              cleardevice;
              fai(grad,Bch,Bar,scala,PA);
              if not traslazione then
              begin
                assecaval(grad,scala,PA,Bch,Bar);
                cleardevice;
                assecavalsol(grad,scala);
                traccia(PA,grad,scala,Bar,Bch,overch,colch,passo);
                if overch<>'S' then traccias(grad,scala)
                               else traccias2(tempo,Bar,grad,scala);
              end;
            end;
            'P':
            begin
              mostracoord(Bar,PA,key,scala);
              cleardevice;
              fai2(grad,Bar,PA);
              if not traslazione then
              begin
                asseprosp(grad,PA,Bar);
                cleardevice;
                asseprospsol(grad);
                cleardevice;
                traccia(PA,grad,3,Bar,Bch,overch,colch,passo);
                if overch<>'S' then traccias(grad,3)
                               else traccias2(tempo,Bar,grad,3);
              end;
            end;
            'L':
            begin
              cleardevice;
              {piantaf(Bar,PA,scala);
              repeat until keypressed;
              assorbi;}
              faip(grad,Bar,scala,PA);
              if not traslazione then
              begin
                asseplan(grad,scala,PA,Bar);
                cleardevice;
                asseplansol(grad,scala);
                traccia(PA,grad,scala,Bar,Bch,overch,colch,passo);
                if overch<>'S' then traccias(grad,scala)
                               else traccias2(tempo,Bar,grad,scala);
              end;
            end;
          end;
          if traslazione then
          begin
            outtextxy(220,100,'Il moto  una traslazione, l''asse di istantanea rotazione non ');
            outtextxy(220,120,'definito. Non ha senso visualizzare tutte le varie entit che   ');
            outtextxy(220,140,'sono ad esso correlate, come le superfici rigate e le polari : ');
            outtextxy(220,160,'sarebbero mostrati soltanto i sistemi di riferimento.           ');
          end;
        end;
      end
      else
      begin
        salva2(True,PA,ch,cti,fil,fil2);
        if (ciclo > 1) then libera(PA);
        sotto(triplexfont,'Prema Invio per continuare',lightgreen,3);
        ch:='S';
        cti:='S';
        traslazione:=false;
        case Sch of
        '1':begin
              st:='prisma.dwg';
              stf:='striscia.fct';
            end;
        '2':begin
              st:='asta.dwg';
              stf:='barra.fct';
            end;
        '3':begin
              st:='trott.dwg';
              stf:='coni.fct';
            end;
        '4':begin
              st:='suppira.dwg';
              stf:='spirale.fct';
            end;
        '5':begin
              st:='pend.dwg';
              stf:='focault.fct';
            end;
        '6':begin
              st:='ogiva.dwg';
              stf:='proiett.fct';
            end;
        '7':begin
              st:='cubo.dwg';
              stf:='osc1.fct'
            end;
        '8':begin
              st:='elle.dwg';
              stf:='roto2.fct';
            end;
        '9':begin
              st:='cubo.dwg';
              stf:='fiore.fct';
            end;
        '0':begin
              st:='trott2.dwg';
              stf:='trott.fct';
            end;
        end;
        if controlla('centro.fct') then
        begin
          unsolido('Solido utilizzato',st);
          repeat until keypressed;
          assorbi;
        end;
        clearviewport;
        unafunzione('Moto prescelto',stf);
        repeat until keypressed;
        assorbi;
        assign(store,st);
        leggi(store,PA);
        assign(fun,stf);
        leggifunc(fun,grad);
        setviewport(0,0,getmaxx,getmaxy,clipon);
        setbkcolor(black);
        cleardevice;
        settextstyle(smallfont,horizdir,4);
        settextjustify(centertext,bottomtext);
        baric(PA,Bar);
        tempo:=3;
        overch:='S';
        colch:='N';
        case sch of
        '3':begin
              Bar.z:=15;
              qpiano:=Bar.z+90;
              Bch:='S';
              overch:='D';
            end;
        '5':begin
              Bar.z:=120;
              qpiano:=130;
              Bch:='S';
              overch:='D';
            end;
        '6':begin
              qpiano:=Bar.z;
              Bch:='N';
              overch:='D';
            end;
        '7':begin
              qpiano:=Bar.z;
              Bch:='N';
              colch:='S';
              passo:=10;
              overch:='D';
            end;
        '8':tempo:=0;
        '9':begin
              qpiano:=45;
              Bch:='S';
              overch:='D';
            end;
        '0':begin
              Bar.z:=15;
              qpiano:=70;
              bch:='S';
              Overch:='D';
            end;
        end;
        cambia(PA,Bar);
        deriva(grad,deri);
        if not checkpiana(grad,deri) then overch:='D';
        scala:=3;
        cleardevice;
        assorbi;
        faip(grad,Bar,scala,PA);
        cleardevice;
        fai(grad,Bch,Bar,scala,PA);
        assecaval(grad,scala,PA,Bch,Bar);
        cleardevice;
        assecavalsol(grad,scala);
        traccia(PA,grad,scala,Bar,Bch,overch,colch,passo);
        if overch<>'S' then traccias(grad,scala)
                       else traccias2(tempo,Bar,grad,scala);
        st:=stsic;
        stf:=stfsic;
      end;
      settextstyle(defaultfont,Horizdir,1);
      settextjustify(0,0);
      outtextXY(50,300,'Fine lavoro ?(S/N)');
      endkey:=UpCase(readkey);
      cleardevice;
      sfondo;
      salva2(False,PA,ch,cti,fil,fil2);
      if (Sch<>'N') and ((stsic='#') or (stfsic='#')) then param:=false;
      if not assoluto then
      begin
        torna(PA,Bar);
        assoluto:=true;
      end;
    until endkey='S';
    if not Verr then
    begin
      clearviewport;
      fine;
      libera(PA);
      closegraph;
    end;
  end;

end.
