unit mecc;

interface

uses crt,graph;

procedure pres(var Verr:boolean;path:string);
procedure sfondo;
procedure terna(Var ch:char);
procedure legenda(var ch:char);
procedure inizializza(var Err:boolean;path:string);
procedure sotto(st:string;col:word;dim:integer);

implementation

procedure inizializza (var Err:boolean;path:string);
var grdriver:integer;
    grmode:integer;              {Inizializza la grafica}
    grerr:integer;
begin
  detectgraph(grdriver,grmode);
  if grdriver=vga then
  begin
    grmode:=vgamed;
    grdriver:=vga;
  end;
  initgraph(grdriver,grmode,path);
  grerr:=graphresult;
  if (grerr=grOk) and ((grdriver=vga) or (grdriver=ega)) then Err:=false
                                                         else Err:=true;
end;

procedure sotto(st:string;col:word;dim:integer);
var info:textsettingstype;
    color:word;
begin                               {stampa "st" nel riquadro secondario}
  getTextsettings(info);
  color:=getcolor;
  setviewport(81,281,559,329,clipon);
  clearviewport;
  setcolor(col);
  settextstyle(triplexfont,Horizdir,dim);
  settextjustify(centertext,bottomtext);
  outtextxy(240,30,st);
  setcolor(color);
  with info do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
  setviewport(101,51,539,229,clipon);
end;

procedure legenda(var ch:char);
var textinfo:textsettingstype;
    color:word;
                                {Mostra la legenda}
begin
  color:=getcolor;
  gettextsettings(textinfo);
  settextjustify(0,0);
  sotto('Legenda',green,4);
  clearviewport;
  setcolor(white);
  line(10,14,60,14);
  line(10,18,60,18);
  setcolor(lightred);
  line(10,34,60,34);
  line(10,38,60,38);
  setcolor(lightgreen);
  line(10,54,60,54);
  line(10,58,60,58);
  setcolor(lightmagenta);
  line(10,94,60,94);
  line(10,98,60,98);
  setcolor(lightcyan);
  line(10,134,60,134);
  line(10,138,60,138);
  setcolor(white);
  outtextxy(10,20,'       : Spigoli del solido');
  outtextxy(10,40,'       : Assi coordinati solidali al moto rigido');
  outtextxy(10,60,'       : Asse istantaneo di moto');
  outtextxy(10,80,'         e polare fissa');
  outtextxy(10,100,'       : Proiezione degli assi cartesiani sul piano ');
  outtextxy(10,120,'         orizzontale che individua le polari');
  outtextxy(10,140,'       : Polare solidale ed Assi coordinati fissi');
  setcolor(color);
  with textinfo do
  settextjustify(horiz,vert);
  ch:=readkey;
  clearviewport;
end;

procedure terna(var ch:char);
var color:word;
                                     {Mostra la terna fissa}
begin
  color:=getcolor;
  setcolor(lightgreen);
  setTextJustify(0,0);
  settextstyle(defaultfont,horizdir,1);
  line(60,150,60,20);
  outtextxy(70,20,'Z');
  line(60,150,250,150);
  outtextxy(260,160,'X');
  line(60,150,125,95);
  outtextxy(135,95,'Y');
  setcolor(white);
  outtextxy(170,50,'Orientamento del');
  outtextxy(170,70,'sistema di riferimento');
  outtextxy(170,90,'fisso.');
  setTextjustify(centertext,bottomtext);
  sotto('Terna cartesiana',lightmagenta,3);
  ch:=readkey;
  setcolor(color);
end;

procedure sfondo;
var info:Textsettingstype;
    FillInfo: FillSettingsType;
    color,bk:word;                 {Disegna lo sfondo del video}
begin
  getTextsettings(info);
  getfillsettings(fillinfo);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  color:=getcolor;
  bk:=getbkcolor;
  setbkcolor(black);
  setcolor(lightred);
  rectangle(1,1,getmaxx-1,getmaxy-1);
  rectangle(3,3,getmaxx-3,getmaxy-3);
  with fillinfo do
  setfillstyle(9,white);
  floodfill(4,4,getcolor);
  rectangle(100,50,540,230);
  rectangle(80,280,560,330);
  setviewport(101,51,539,229,clipon);
  clearviewport;
  setcolor(lightcyan);
  sotto('',lightmagenta,3);
  setbkcolor(bk);
  setcolor(color);
  with info do
  setTextStyle(font,direction,charsize);
  with fillinfo do
  setFillStyle(pattern,color);
end;

procedure pres(var Verr:boolean;path:string);
var x1,y1,x2,y2,i,j:integer;
    info:Textsettingstype;           {Presentazione iniziale}
    FillInfo: FillSettingsType;
    Err:boolean;
    ch:char;
    color,bk:word;

begin
  getTextsettings(info);
  getfillsettings(fillinfo);
  inizializza(Verr,path);
  if not Verr then
  begin
    color:=getcolor;
    sfondo;
    setcolor(lightcyan);
    setTextjustify(centertext,bottomtext);
    settextstyle(gothicfont,Horizdir,5);
    OuttextXy(220,70,'Asse istantaneo');
    OuttextXy(220,130,'di moto');
    sotto('By Marco Martiri',lightmagenta,3);
    ch:=readkey;
    if ch<>#27 then
    begin
      clearviewport;
      settextstyle(Triplexfont,Horizdir,4);
      outtextXY(220,50,'Studio di un moto');
      outtextXY(220,80,'rigido tridimensionale');
      outtextXY(220,110,'in proiezione prospettica');
      outtextXY(220,140,'od assonometrica.');
      sotto('Universit di Ancona',white,3);
      ch:=readkey;
      if ch<>#27 then
      begin
        clearviewport;
        settextstyle(Defaultfont,Horizdir,1);
        outtextXY(220,20,'Il moto  determinato da sei funzioni: tre regolano');
        outtextXy(220,40,'la traslazione dell''origine solidale al corpo rigido,');
        outtextxy(220,60,'le altre determinano le rotazioni attorno agli assi');
        outtextxy(220,80,'del sistema solidale. Contemporaneamente ');
        outtextxy(220,100,'visualizzato l''asse istantaneo di moto');
        outtextxy(220,120,'(Il segmento rappresentato ha un estremo alla stessa');
        outtextxy(220,140,'quota dell''origine solidale, mentre l''altro vertice');
        outtextxy(220,160,' a distanza costante ).');
        sotto('Facolt di Ingegneria',yellow,3);
        ch:=readkey;
      end;
      if ch<>#27 then
      begin
        clearviewport;
        outtextxy(220,20,'Successivamente  disegnata la superficie rigata');
        outtextxy(220,40,'individuata dall''asse istantaneo di moto.');
        outtextxy(220,60,'Per facilitare la lettura di tale grafico si ');
        outtextxy(220,80,'provedduto a modificare il colore delle rette');
        outtextxy(220,100,'traccianti al variare del tempo.');
        outtextxy(220,120,'Rappresentazioni del moto del solido e della');
        outtextxy(220,140,'superficia rigata sono possibili sia in prospettiva,');
        outtextxy(220,160,'che in assonometria cavaliera e in vista dall''alto.');
        sotto('C.d.L. in Ingegneria Elettronica',lightgreen,3);
        ch:=readkey;
      end;
      if ch<>#27 then
      begin
        clearviewport;
        outtextxy(220,20,'Infine, con qualsiasi tipo di rappresentazione ');
        outtextxy(220,40,'mostrata la linea intercettata dall''asse di moto su di');
        outtextxy(220,60,'un piano orizzontale che pu essere a quota costante o');
        outtextxy(220,80,'variabile (quella dell''origine del sistema soli-');
        outtextxy(220,100,'dale). E'' inoltre disponibile una piccola libreria di');
        outtextxy(220,120,'solidi e di funzioni, che pu essere ampliata durante');
        outtextxy(220,140,'le sessioni di lavoro. Tali dati sono immagazzinati in');
        outtextxy(220,160,'file di testo, semplici da consultare e da modificare.');
        sotto('Anno accademico 1991/92',lightred,3);
        ch:=readkey;
      end;
      if ch<>#27 then
      begin
        clearviewport;
        terna(ch);
        if ch<>#27 then
        legenda(ch);
        if ch<>#27 then
        begin
          outtextxy(220,20,'Per disegnare i vari solidi in assonometria');
          outtextxy(220,40,'si sono proiettati i loro vertici su di un quadro');
          outtextxy(220,60,'posto tra l''oggetto da rappresentare e l''osser-');
          outtextxy(220,80,'vatore, i cui piedi custituiscono l''origine della ter-');
          outtextxy(220,100,'na fissa. Pertanto se l''oggetto, durante un moto, at-');
          outtextxy(220,120,'traversasse il quadro di proiezione, la raffigurazione');
          outtextxy(220,140,'sarebbe certamente scorretta. Tale limitazione  evi-');
          outtextxy(220,160,'dente nella prospettiva, mentre non ricorre in pianta.');
          sotto('Precisazioni',lightgreen,3);
          ch:=readkey;
        end;
      end;
      if ch<>#27 then
      begin
        settextstyle(triplexfont,horizdir,3);
        clearviewport;
        outtextxy(220,30,'ATTENZIONE :');
        settextstyle(smallfont,horizdir,5);
        outtextxy(220,60,'Vista la dimensione del programma e l''uso intenso di');
        outtextxy(220,80,'memoria dinamica, durante la formazione delle finestre');
        outtextxy(220,100,'di dialogo, potrebbe insorgere un errore di heap-');
        outtextxy(220,120,'overflow. In tal caso si consiglia di liberare la me-');
        outtextxy(220,140,'moria dai programmi residenti non indispensabili, come');
        outtextxy(220,160,'il driver del mouse, prima di lanciare questo file.');
        ch:=readkey;
      end;
      if ch<>#27 then
      begin
        sotto('Codifiche per i file di archivio',lightgreen,3);
        settextstyle(defaultfont,horizdir,1);
        clearviewport;
        outtextxy(220,20,'Qualora si desideri redarre gli archivi conteneti le');
        outtextxy(220,40,'informazioni relative ai solidi (vertici e spigoli) ');
        outtextxy(220,60,'con un editore di testo esterno, come caldamente con-');
        outtextxy(220,80,'siglio,  necessario conoscere le regole di codifica');
        outtextxy(220,100,'utilizzate. Il dato fondamentale, il punto 3d, va');
        outtextxy(220,120,'scritto come tre numeri allineati separati da uno');
        outtextxy(220,140,'spazio. Ciascuna riga deve contenere un unico dato.');
        outtextxy(220,160,'Segue ora la sequenza corretta dei dati:');
        ch:=readkey;
      end;
      if ch<>#27 then
      begin
        clearviewport;
        setcolor(white);
        outtextxy(220,20,'Prima riga -->numero dei vertici (intero);');
        outtextxy(220,40,'Linee successive -->elenco dei vertici;   ');
        setcolor(lightcyan);
        outtextxy(220,60,'Segue quindi il numero dei vertici legati con altri ');
        outtextxy(220,80,'per formare gli spigoli. Elenco di questi vertici:  ');
        setcolor(white);
        outtextxy(220,100,'vertice                                           ');
        outtextxy(220,120,'coordinate vertice                                ');
        outtextxy(220,140,'legame_                                           ');
        outtextxy(220,160,'numero vertici collegati e, a capo, il loro elenco');
        setcolor(lightcyan);
        ch:=readkey;
      end;
      if ch<>#27 then
      begin
        clearviewport;
        outtextxy(220,20,'E'' possibile utilizzare la medesima tecnica anche per');
        outtextxy(220,40,'scrivere nuovi moti, ma  pi conveniente editare un');
        outtextxy(220,60,'file di moto (*.fct) solo per corregere le funzioni.');
        outtextxy(220,80,'Le regole sono simili a quelle gi viste: nome della');
        outtextxy(220,100,'grandezza da variare,tipo di funzione,valore dei pa-');
        outtextxy(220,120,'rametri. Ricordo che le funzioni devono essere sei.');
        outtextxy(220,140,'Per un esame pi approfondito si rimanda al manuale.');
        setcolor(white);
        outtextxy(220,170,'P.S. I file dei solidi devono avere estensione .dwg .');
        setcolor(lightcyan);
        ch:=readkey;
      end;
      if ch<>#27 then
      begin
        settextstyle(sansseriffont,horizdir,4);
        clearviewport;
        outtextxy(220,55,'Si ringrazia, per');
        outtextxy(220,95,'le idee ed i consigli,');
        outtextxy(220,135,'Gianluca Mei.');
        sotto('Ringraziamenti',green,3);
        ch:=readkey;
      end;
    end;
    settextstyle(gothicfont,Horizdir,7);
    clearviewport;
    outtextxy(220,100,'Buon lavoro !');
    sotto('Premere un tasto per continuare',white,3);
    ch:=readkey;
    setcolor(color);
  end
  else
  begin
     closegraph;
     clrscr;
     writeln;
     writeln('Scheda video insufficiente (richiesta almeno EGA)');
     writeln('o drivers video non trovati nella directory corrente.');
     writeln('''Asse Istantaneo di Moto'' non pu funzionare.');
  end;
end;

end.